<?php
/**
 Plugin Name: WP Robot 3
 Plugin URI: http://www.wprobot.net/
 Version: 3.00
 Description: Automatically post content related to any topic of your choice to your weblog.
 Author: WP Robot
 Author URI: http://www.wprobot.net/
 License: Commercial. For personal use only. Not to give away or resell
*/
/*  Copyright 2009 Lunatic Studios
*/

if (version_compare(PHP_VERSION, '5.0.0.', '<'))
{
	die(__("WP Robot requires php 5 or a greater version to work.", "wprobot"));
}

if (!defined('WP_CONTENT_URL')) {
   define('WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
}
define('WPR_URLPATH', WP_PLUGIN_URL.'/'.plugin_basename( dirname(__FILE__) ).'/' );

function wpr_plugin_init () {
	load_plugin_textdomain('wprobot');
}
add_action ('init', 'wpr_plugin_init');

// Global Variables
$wpr_version = "3.00";
$wpr_table_campaigns = $wpdb->prefix . "wpr_campaigns";	
$wpr_table_templates = $wpdb->prefix . "wpr_templates";	
$wpr_table_posts = $wpdb->prefix . "wpr_posts";	
$wpr_table_errors = $wpdb->prefix . "wpr_errors";	
$modules = array("amazon","article","clickbank","ebay","flickr","yahooanswers","yahoonews","youtube","rss","translation");

@include_once("func.php");	
//include_once("wprupgrade.php");	
foreach ($modules as $module) {$inc = @include_once("modules/$module.php");if($inc == 1) {$loadedmodules[] = $module;}} // Modules

function wpr_default_options($update=0) {
	global $modules;

	@include_once("default-options.php");
	
	$options = unserialize(get_option("wpr_options"));	

		$options['wpr_poststatus'] = 'published';
		$options['wpr_autotag'] = 'Yes';
		$options['wpr_resetcount'] = 'no';
		$options['wpr_badwords'] = 'what;which;where;when;does;that;with;while;then;your;other;have;make;will';
		$options['wpr_randomize'] = 'yes';
		$options['wpr_randomize_comments'] = 'no';
		$options['wpr_help'] = 'Yes';
		$options['wpr_openlinks'] = 'no';
		$options['wpr_authorid'] = 1;
		$options['wpr_err_retries'] = 3;
		$options['wpr_err_maxerr'] = 2;
		$options['wpr_err_minmod'] = 1;
		$options['wpr_err_disable'] = 5;
		$options["wpr_global_exclude"] = "";
		$options['wpr_check_unique_old'] = "No";
		foreach($modules as $module) {
			$function = "wpr_".$module."_options_default";
			if(function_exists($function)) {
				$moptions = $function();
				foreach($moptions as $moption => $default) {
					if(!empty($defaults[$moption])) {
						$options[$moption] = $defaults[$moption];
					} else {
						$options[$moption] = "$default";
					}
				}
			}
		}
	if($update == 1) {
		update_option("wpr_options", serialize($options));	
		return $options;
	} else {
		$croncode = substr(md5(time()), 0, 8);
		add_option('wpr_cron',$croncode);	
		add_option('wpr_cloak',"No");
		add_option("wpr_options", serialize($options));	
	}
}

function wpr_default_options_single($module,$options) {
	//$options = unserialize(get_option("wpr_options"));	
	$function = "wpr_".$module."_options_default";
	if(function_exists($function)) {
		$moptions = $function();
		foreach($moptions as $moption => $default) {
			if(!empty($defaults[$moption])) {
				$options[$moption] = $defaults[$moption];
			} else {
				$options[$moption] = "$default";
			}
		}
	}
	update_option("wpr_options", serialize($options));	
}

function wpr_activate() {
   global $wpdb;
   
    $wpr_db_ver = 94;
	$wpr_table_campaigns = $wpdb->prefix . "wpr_campaigns";	
	$wpr_table_templates = $wpdb->prefix . "wpr_templates";	
	$wpr_table_posts = $wpdb->prefix . "wpr_posts";	
	$wpr_table_errors = $wpdb->prefix . "wpr_errors";		
   
	if(get_option('wpr_db_ver') != $wpr_db_ver) {

	if ( !empty($wpdb->charset) )
		$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
	
    $sql[] = "CREATE TABLE ".$wpr_table_campaigns." (
        id BIGINT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		name VARCHAR(255) NOT NULL,
		ctype VARCHAR(255) NOT NULL,
		keywords longtext NOT NULL,
		categories longtext NOT NULL,
		templates longtext NOT NULL,
		cinterval BIGINT(20) NOT NULL,
		period VARCHAR(255) NOT NULL,
		postspan VARCHAR(255) NOT NULL,
		replacekws longtext NOT NULL,
		excludekws longtext NOT NULL,
		amazon_department VARCHAR(255) NOT NULL,
		ebay_cat VARCHAR(255) NOT NULL,
		yahoo_cat VARCHAR(255) NOT NULL,
		translation VARCHAR(255) NOT NULL,
		customfield longtext NOT NULL,
		posts_created BIGINT(20) NOT NULL DEFAULT 0,
		pause INT(1) NOT NULL DEFAULT 0	
		) {$charset_collate};";
		
    $sql[] = "CREATE TABLE ".$wpr_table_templates." (
        id BIGINT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		type VARCHAR(255) NOT NULL,
		typenum INT(4) NOT NULL DEFAULT 1,	
		content longtext NOT NULL,
		title longtext NOT NULL,
		comments_amazon INT(1) NOT NULL DEFAULT 0,
		comments_flickr INT(1) NOT NULL DEFAULT 0,
		comments_yahoo INT(1) NOT NULL DEFAULT 0,
		comments_youtube INT(1) NOT NULL DEFAULT 0,
		name VARCHAR(255) NOT NULL
		) {$charset_collate};";	

    $sql[] = "CREATE TABLE ".$wpr_table_posts." (
        id BIGINT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		campaign BIGINT(20) NOT NULL,
		keyword VARCHAR(255) NOT NULL,		
		module VARCHAR(255) NOT NULL,
		unique_id longtext NOT NULL,
		time VARCHAR(255) NOT NULL
		) {$charset_collate};";		
		
    $sql[] = "CREATE TABLE ".$wpr_table_errors." (
        id BIGINT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		campaign BIGINT(20) NOT NULL,
		keyword VARCHAR(255) NOT NULL,
		module VARCHAR(255) NOT NULL,	
		reason VARCHAR(255) NOT NULL,			
		message longtext NOT NULL,
		time VARCHAR(255) NOT NULL
		) {$charset_collate};";			

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);	
		
	if (get_option("wpr_options") == false || get_option("wpr_options") == "") { 	
		wpr_default_options();
	}
	
	update_option('wpr_db_ver',$wpr_db_ver);
	
	}			
}
register_activation_hook(__FILE__, 'wpr_activate');



function wpr_import_options() {
	global $modules;
	$options = unserialize(get_option("wpr_options"));	
	$options['wpr_poststatus'] = get_option('ma_poststatus');
	$options['wpr_autotag'] = get_option('ma_autotag');
	$options['wpr_resetcount'] = get_option('ma_resetcount');
	$options['wpr_badwords'] = get_option('ma_badwords');
	$options['wpr_randomize'] = get_option('ma_randomize');
	$options['wpr_authorid'] = get_option('ma_authorid');
	$options['wpr_check_unique_old'] = "Yes";
		foreach($modules as $module) {
			$function = "wpr_".$module."_options_default";
			if(function_exists($function)) {
				$moptions = $function();
				foreach($moptions as $moption => $default) {
					$oldoption = str_replace("wpr_","ma_",$moption);
					if( $oldoption != "ma_aa_revtemplate" ) {
						$geto = get_option($oldoption);
						if($geto != " " && !empty($geto)) {
							$options[$moption] = $geto;
						}
					}
				}
			}
		}
	update_option("wpr_options", serialize($options));
	return $options;
}

function wpr_add_pages() {

    add_menu_page('WP Robot 3', 'WP Robot 3', 8, 'wpr-campaigns', 'wpr_toplevel');
    add_submenu_page('wpr-campaigns', 'Campaigns', 'Campaigns', 8, 'wpr-campaigns', 'wpr_toplevel');	
	add_submenu_page('wpr-campaigns', 'Create Campaign', 'Create Campaign', 8, 'wpr-add', 'wpr_add');	
    add_submenu_page('wpr-campaigns', 'Options', 'Options', 8, 'wpr-options', 'wpr_sub_options');
    add_submenu_page('wpr-campaigns', 'Templates', 'Templates', 8, 'wpr-templates', 'wpr_sub_templates');
	add_submenu_page('wpr-campaigns', 'Log', 'Log', 8, 'wpr-log', 'wpr_errors');		
    add_submenu_page('wpr-campaigns', '', '', 8, 'wpr-single', 'wpr_single');	
	
}
add_action('admin_menu', 'wpr_add_pages');

function wpr_create_campaign() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates;
	
	$options = unserialize(get_option("wpr_options"));	
	
	if($_POST['keywords'] == "" && $_POST['type'] == "keyword") {
		echo '<div class="updated"><p>'.__("Please enter at least one keyword!", "wprobot").'</p></div>';	
	} elseif($_POST['feeds'] == "" && $_POST['type'] == "rss") {
		echo '<div class="updated"><p>'.__("Please enter at least one RSS feed!", "wprobot").'</p></div>';	
	} elseif($_POST['nodes'] == "" && $_POST['type'] == "nodes") {
		echo '<div class="updated"><p>'.__("Please enter at least one Amazon BrowseNode!", "wprobot").'</p></div>';			
	} elseif($_POST['categories'] == "") {
		echo '<div class="updated"><p>'.__("Please enter at least one category!", "wprobot").'</p></div>';	
	} elseif($_POST['interval'] == "") {
		echo '<div class="updated"><p>'.__("Please enter a post interval!", "wprobot").'</p></div>';		
	} elseif($_POST['name'] == "") {
		echo '<div class="updated"><p>'.__("Please enter a name for your campaign!", "wprobot").'</p></div>';	
	} elseif($_POST['title1'] == "" || $_POST['content1'] == "" || $_POST['chance1'] == "") {
		echo '<div class="updated"><p>'.__("Please enter at least one template for your campaign!", "wprobot").'</p></div>';
	} elseif($_POST['amazon_department'] == "All" && $_POST['type'] == "nodes") {
		echo '<div class="updated"><p>'.__("Amazon Department can not be 'All' in a BrowseNodes campaign! You can to select the correct Department your Nodes belong to (Amazon API requirement).", "wprobot").'</p></div>';	
	} else {	
	
		$type = $_POST['type'];
   
		// Keywords
		$_POST['keywords'] = stripslashes($_POST['keywords']);
		$keywordsinput = str_replace("\r", "", $_POST['keywords']);
		$keywordsinput = explode("\n", $keywordsinput);    
		
		$i=0;
		$keywords = array();
		
		if($_POST["edit"]) {// GET OLD KEYWORDS FOR NUMs $oldcamp->postspan
			$edit = 1;
			$oldcamp = $wpdb->get_row( "SELECT keywords,postspan FROM $wpr_table_campaigns WHERE id = '" . $_POST["edit"] . "'" );
			$oldkeywords = unserialize($oldcamp->keywords);	
		}

		if($type == "keyword") {
			foreach( $keywordsinput as $keyword) {
				if($keyword != "") {
					$keywords[$i] = array($keyword);
					if($edit == 1) {
						$kwnums = false;
						foreach($oldkeywords as $key => $oldkeyword)  {
							if($oldkeyword[0] == $keyword) {$kwnums = $oldkeyword[1];}
						}
					}
					if($kwnums != false) {
						$keywords[$i][] = $kwnums;
					} else {
						$keywords[$i][] = array("total" => 0);
					}
					$keywords[$i]["skipped"] = 0;
				}
				$i++;
			}
		} elseif($type == "rss") {
			$rssinput = str_replace("\r", "", $_POST['feeds']);
			$rssinput = explode("\n", $rssinput);
			foreach( $rssinput as $rss) {
				if($rss != "") {
					$keywords[$i] = array($keywordsinput[$i]);
					if($edit == 1) {
						$kwnums = false;
						foreach($oldkeywords as $key => $oldkeyword)  {
							if($oldkeyword[0] == $keywordsinput[$i]) {$kwnums = $oldkeyword[1];}
						}
					}					
					if($kwnums != false) {
						$keywords[$i][] = $kwnums;
					} else {
						$keywords[$i][] = array("total" => 0);
					}
					$keywords[$i]["skipped"] = 0;
					$keywords[$i]["feed"] = $rss;
				}
				$i++;	
			}
		} elseif($type == "nodes") {
			$nodesinput = str_replace("\r", "", $_POST['nodes']);
			$nodesinput = explode("\n", $nodesinput);	
			foreach( $nodesinput as $node) {
				$nodename = wpr_aws_getnodename($node);echo $nodename;
				if($node != "" && $nodename != false) {
					$keywords[$i] = array($keywordsinput[$i]);
					if($edit == 1) {
						$kwnums = false;
						foreach($oldkeywords as $key => $oldkeyword)  {
							if($oldkeyword[0] == $keywordsinput[$i]) {$kwnums = $oldkeyword[1];}
						}
					}					
					if($kwnums != false) {
						$keywords[$i][] = $kwnums;
					} else {
						$keywords[$i][] = array("total" => 0);
					}
					$keywords[$i]["skipped"] = 0;
					$keywords[$i]["bnn"] = "$nodename";					
					$keywords[$i]["node"] = $node;
				}
				$i++;	
			}		
		}	
		$keywords = $wpdb->escape(serialize($keywords));		

		// Categories
		if($_POST['multisingle'] == "single") {
			$categories = array();
			//$categories["type"] = "single";
			$categories[0]["id"] = $_POST['categories'];
		} else {
			$categories = array();		
			$_POST['categories'] = stripslashes($_POST['categories']);			
			$categoriesinput = str_replace("\r", "", $_POST['categories']);
			$categoriesinput = explode("\n", $categoriesinput);
			$i = 0;	
			foreach($categoriesinput as $category) {
				if($category != "") {	
					$category_ID = $wpdb->get_var( "SELECT term_id FROM $wpdb->terms WHERE name = '" . $category . "'" );						

					if(!$category_ID && $_POST['createcats'] == "yes") {
						$category_ID = wp_create_category( ucwords($category) );
					}	
					$categories[$i]["name"] = $category;
					$categories[$i]["id"] = $category_ID;
				}
				$i++;
			}	
			/*if(count($categories) == 1) {
				$categories["type"] = "single";
			} else {
				$categories["type"] = "multi";			
			}	*/	
		}
		$categories = $wpdb->escape(serialize($categories));
		
		// Templates
		$templates = array();	
		for ($i = 1; $i <= $_POST['tnum']; $i++) {
			if($_POST["chance$i"] > 0) {
				$templates[$i]["title"] = stripslashes($_POST["title$i"]);
				$templates[$i]["content"] = stripslashes($_POST["content$i"]);
				$templates[$i]["chance"] = $_POST["chance$i"];
				$templates[$i]["comments"]["amazon"] = $_POST["comments_amazon$i"];
				$templates[$i]["comments"]["flickr"] = $_POST["comments_flickr$i"];
				$templates[$i]["comments"]["yahooanswers"] = $_POST["comments_yahoo$i"];
				$templates[$i]["comments"]["youtube"] = $_POST["comments_youtube$i"];
			}
		}
		//$templates = array_values($templates); -- MAKES FIRST TEMPLATE "0"
		$templates = serialize($templates);
		
		// Optional settings
		$amadept = $_POST['amazon_department'];
		$yahoocat = $_POST['yahoo_category'];
		$ebaycat = $_POST['ebay_category'];
		
		$_POST['replace'] = stripslashes($_POST['replace']);
		$replaceinput = str_replace("\r", "", $_POST['replace']);
		$replaceinput = explode("\n", $replaceinput);    
		
		$i=0;
		$replaces = array();
		foreach( $replaceinput as $replace) {
			if($replace != "") {
				$replace = explode("|", $replace);  
				$replaces[$i]["from"] = $replace[0];
				$replaces[$i]["to"] = str_replace('\"', "", $replace[1]);
				$replaces[$i]["chance"] = $replace[2];
			}
			$i++;
		}
		$replaces = $wpdb->escape(serialize($replaces));	
		
		$_POST['exclude'] = stripslashes($_POST['exclude']);
		$exclude = str_replace("\r", "", $_POST['exclude']);
		$exclude = explode("\n", $exclude);
		foreach($exclude as $key => $value) {
			if($value == "") {
				unset($array[$key]);
			}
		}
		$exclude = array_values($exclude); 
		$exclude = $wpdb->escape(serialize($exclude));
		
		$name = $_POST['name'];
		$postevery = $_POST['interval'];
		$cr_period = $_POST['period'];
		$postspan = "WPR_" . $postevery . "_" . $cr_period;	
		
		$customfield = array();
		$customfield["name"] = $_POST['cf_name'];
		$customfield["value"] = $_POST['cf_value'];
		$customfield = serialize($customfield);
		
		$translation = array();
		$translation["chance"] = $_POST['transchance'];
		$translation["from"] = $_POST['trans1'];
		$translation["to1"] = $_POST['trans2'];
		$translation["to2"] = $_POST['trans3'];
		$translation["to3"] = $_POST['trans4'];
		$translation["comments"] = $_POST['trans_comments'];
		$translation = serialize($translation);
		
		if($_POST['autopost'] == "yes") {
			$pause = 0;
		} else {
			$pause = 1;
		}
		
		if($_POST["edit"]) {
			$uid = $_POST["edit"];
			$update = "UPDATE " . $wpr_table_campaigns . " SET name = '$name', ctype = '$type', keywords = '$keywords'
					, categories = '$categories', templates = '$templates', cinterval = '$postevery', period = '$cr_period', postspan = '$postspan'
					, replacekws = '$replaces', excludekws = '$exclude', amazon_department = '$amadept', ebay_cat = '$ebaycat', yahoo_cat = '$yahoocat'
					, translation = '$translation', customfield = '$customfield', pause = '$pause' WHERE id = $uid";
			$results = $wpdb->query($update);
			if ($results) {
				if($postspan != $oldcamp->postspan) {		
					wpr_set_schedule($postevery, $cr_period);	
					wp_reschedule_event( time(), $postspan, "wprobothook", array($uid) );
					wpr_delete_schedule($oldcamp->cinterval, $oldcamp->period);
				}
				echo '<div class="updated"><p>'.__('Campaign has been updated! Go to the <a href="?page=wpr-single&id='.$uid.'">control panel</a> to view details.', "wprobot").'</p></div>';		
			} else {
				echo '<div class="updated"><p>'.__("Campaign could not be updated!", "wprobot").'</p></div>';			
			}		
		} else {
			$insert = "INSERT INTO " . $wpr_table_campaigns . " SET name = '$name', ctype = '$type', keywords = '$keywords'
			, categories = '$categories', templates = '$templates', cinterval = '$postevery', period = '$cr_period', postspan = '$postspan'
			, replacekws = '$replaces', excludekws = '$exclude', amazon_department = '$amadept', ebay_cat = '$ebaycat', yahoo_cat = '$yahoocat'
			, translation = '$translation', customfield = '$customfield', pause = '$pause'";
			$result = $wpdb->query($insert);
			$insid = mysql_insert_id();
			
			if ($result) {	
			
				$sql = "SELECT LAST_INSERT_ID() FROM " . $wpr_table_campaigns;
				$id = $wpdb->get_var($sql);	$linkid = $id;
				if($linkid != $insid) {$linkid = $insid;}
				
				wpr_set_schedule($postevery, $cr_period);	
				$lag = $_POST['delaystart'] * 3600;
				if($lag == "" || !is_numeric($lag) || $lag < 0) {$lag = 200;}	
				
				wp_schedule_event( time()+$lag, $postspan, "wprobothook" , array($id) );

				$next = wp_next_scheduled( "wprobothook", array($id) );
				if($next == 0 || $next == "0" || $next == null || $next == "") {
					wp_schedule_event( time()+$lag, $postspan, "wprobothook" , array($id) );
				}
				
				echo '<div class="updated"><p>'.__('Campaign "'.$name.'" has been added! Go to the <a href="?page=wpr-single&id='.$linkid.'">control panel</a> to view details.', 'wprobot').'</p></div>';		
			}
		}	
	}
}

function wpr_errors() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates, $wpr_table_errors;
	
	$options = unserialize(get_option("wpr_options"));		
	if ($options['wpr_installed'] != "yes") {
		echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Installation</h3><p>'.__('Please go <a href="?page=wpr-campaigns">here</a> to finish the installation of WP Robot first.', 'wprobot').'</p></div></div>';
		return false;
	}		
	
	if(!$_GET['id']) {
		$where = "";
	} else {
		$id = $_GET['id'];
		$where = " WHERE campaign = '$id'";
	}
	
	if(!$_GET['keyword']) {
		$where2 = "";
	} else {
		$keyword = $_GET['keyword'];
		$where2 = " AND keyword = '$keyword'";
	}

	if($_POST['wpr_clear_log']) {
		$results = $wpdb->query("DELETE FROM $wpr_table_errors$where$where2;");	
		if($results) {
			echo '<div class="updated"><p>'.__('Log has been cleared.', 'wprobot').'</p></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Log could not be cleared.', 'wprobot').'</p></div>';		
		}
	}			

	$errors = $wpdb->get_results("SELECT * FROM " . $wpr_table_errors . "$where$where2 ORDER BY id DESC LIMIT 100");  
	
	include("display-errors.php");

}

function wpr_campaign_controls() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates;
	
	if($_GET['pause']) {
		$pause = $_GET['pause'];
		$wpdb->update( $wpr_table_campaigns, array( 'pause' => 1 ), array( 'ID' => $pause ), array( '%d' ), array( '%d' ) );
		echo '<div class="updated"><p>'.__('Campaign has been paused.', 'wprobot').'</p></div>';	
	}	
	
	if($_GET['unpause']) {
		$pause = $_GET['unpause'];
		$wpdb->update( $wpr_table_campaigns, array( 'pause' => 0 ), array( 'ID' => $pause ), array( '%d' ), array( '%d' ) );
		echo '<div class="updated"><p>'.__('Campaign has been continued.', 'wprobot').'</p></div>';	
	}		
	
	if($_GET['delete'] && !$_POST['deleteall']) {
		$_POST["delete"] = array($_GET["delete"]);
		wpr_delete_campaign();
	}
	
	if($_POST['deleteall']) {
		if($_POST["delete"] == "" || $_POST["delete"] == 0 || $_POST["delete"] == null) {
			echo '<div class="updated"><p>Please select at least one campaign!</p></div>';				
		} else {
			wpr_delete_campaign();
		}
	}	
	
	if($_POST['wpr_runnow'] || $_GET['wpr_runnow']) {
		if($_POST['wpr_runnow']) {
			$_GET['wpr_runnow'] = false;
			if($_POST["delete"] == "" || $_POST["delete"] == 0 || $_POST["delete"] == null) {
				echo '<div class="updated"><p>'.__('Please select at least one campaign!', 'wprobot').'</p></div>';				
			} else {
				$posted = 0;
				$skipped = 0;
				$bulk = $_POST["wpr_bulk"];
				$delete = $_POST["delete"];
				$array = implode(",", $delete);
				
				if($bulk == "" || $bulk == 0 || $bulk == null) {$bulk = 1;}
				
				if($_POST['time'] && $_POST['backdate'] == "yes") {
					$sp1 = $_POST['timespace'];
					$sp2 = $_POST['timespace2'];
					$time = explode("-", $_POST['time']);					
				}			
				
				for($i=0; $i < $bulk; $i++) { 
					foreach ($_POST['delete']  as $key => $value) {
					
						if($_POST['kws']) {
							$keywords = $_POST['kws'];
							$keyword = $keywords[array_rand($keywords)];
						} else {
							$keyword = "";
						}
					
						if($_POST['time'] && $_POST['backdate'] == "yes") {				
							$comment_date = mktime(rand(0,23), rand(0, 59), rand(0, 59), $time[1], $time[2] + $i* rand($sp1,$sp2), $time[0]);
							$_POST['postdate']=date("Y-m-d H:i:s", $comment_date);									
						}			
						$result = wpr_poster($value,$keyword,1);
						if($result == true) {$posted++;} else {$skipped++;}
					}	
				}
				if($posted > 0) {
					if($skipped > 0) {$sktxt = __(' and '.$skipped.' posts have been skipped. Please see the <a href="?page=wpr-log">error log</a> for details', 'wprobot');} else {$sktxt = '';}
					echo '<div class="updated"><p>'.__(''.$posted.' posts have been created successfully'.$sktxt.'!', 'wprobot').'</p></div>';	
				} else {
					echo '<div class="updated"><p>'.__('Error: '.$skipped.' posts could not be created. Please see the <a href="?page=wpr-log">error log</a> for details.', 'wprobot').'</p></div>';						
				}
			}
		} elseif($_GET['wpr_runnow'] && !$_POST['wpr_post'] && !$_POST['wpr_deleteit']) {
			$result = wpr_poster($_GET['wpr_runnow'],$_GET['keyword'],1);	
			if($result == true) {
				echo '<div class="updated"><p>'.__('Post has been created successfully!', 'wprobot').'</p></div>';		
			} else {
				echo '<div class="updated"><p>'.__('Error: Post could not be created. Please see the <a href="?page=wpr-log&id='.$_GET['wpr_runnow'].'">error log</a> for details.', 'wprobot').'</p></div>';		
			}
		}	
	}
}

function wpr_single() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates, $wpr_table_errors;
	
	wpr_campaign_controls();
	
	if(!$_GET['id']) {
		_e("Error: No Campaign ID specified", 'wprobot');
	} else {
		$id = $_GET['id'];
		$result = $wpdb->get_row("SELECT * FROM " . $wpr_table_campaigns . " WHERE id = '$id'");  
		$keywords = unserialize($result->keywords);	
		$categories = unserialize($result->categories);	
		$templates = unserialize($result->templates);
	
		if($_POST['resetkws']){	
			$i = 0;
			foreach($keywords as $keyword) {
				if($keywords[$i]["skipped"] > 2) {
					$keywords[$i]["skipped"] = 0;	
				}
				$i++;
			}
			$keywords2 = serialize($keywords);
			$sql = "UPDATE " . $wpr_table_campaigns . " SET `keywords` = '".$keywords2."' WHERE `id` = '".$id."'";
			$results = $wpdb->query($sql);	
			if ($results) {				
				echo '<div class="updated"><p>'.__('All disabled keywords have been reset.', 'wprobot').'</p></div>';
				$result = $wpdb->get_row("SELECT * FROM " . $wpr_table_campaigns . " WHERE id = '$id'");  
				$keywords = unserialize($result->keywords);					
			} else {
				echo '<div class="updated"><p>'.__('Error: Keywords could not be reset!', 'wprobot').'</p></div>';				
			}				
		}	
		
		if($_POST['deletekws']){
			$dkws = $_POST['kws'];		
			if(!empty($dkws)) {
				foreach($keywords as $key => $keyword) {
					if($result->ctype == "keyword") {$ksearch = $keyword[0];} elseif($result->ctype == "rss") {$ksearch = $keyword["feed"];} elseif($result->ctype == "nodes") {$ksearch = $keyword["node"];}
					if(in_array($ksearch, $dkws)) {
						unset($keywords[$key]);
						unset($categories[$key]);
					}
				}
				$keywords = array_values($keywords);
				$categories = array_values($categories); // PROBLEM: MAKES [type] value to [1] !!!
				$keywords2 = serialize($keywords);	
				$categories2 = serialize($categories);	
				$sql = "UPDATE " . $wpr_table_campaigns . " SET `keywords` = '".$keywords2."', `categories` = '".$categories2."' WHERE `id` = '".$id."'";
				$results = $wpdb->query($sql);
				if ($results) {				
					echo '<div class="updated"><p>'.__('Keywords have been deleted.', 'wprobot').'</p></div>';		
				} else {
					echo '<div class="updated"><p>'.__('Error: Keywords could not be deleted!', 'wprobot').'</p></div>';				
				}
			} else {
				echo '<div class="updated"><p>'.__('Error: Please select at least one keyword!', 'wprobot').'</p></div>';					
			}			
		}
		
		if($_GET['kwdelete']){
			foreach($keywords as $key => $keyword) {
				if($keyword[0] == $_GET['keyword']) {
					unset($keywords[$key]);
					unset($categories[$key]);
				}
			}
			$keywords = array_values($keywords);
			$categories = array_values($categories);
			$keywords2 = serialize($keywords);	
			$categories2 = serialize($categories);	
			$sql = "UPDATE " . $wpr_table_campaigns . " SET `keywords` = '".$keywords2."', `categories` = '".$categories2."' WHERE `id` = '".$id."'";
			$results = $wpdb->query($sql);
			if ($results) {				
				echo '<div class="updated"><p>'.__('Keyword has been deleted.', 'wprobot').'</p></div>';		
			} else {
				echo '<div class="updated"><p>'.__('Error: Keyword could not be deleted!', 'wprobot').'</p></div>';				
			}			
		}
		
		$errors = $wpdb->get_results("SELECT * FROM " . $wpr_table_errors . " WHERE campaign = '$id' ORDER BY id DESC LIMIT 10");  
		
		include("display-single.php");
	}	
}

function wpr_install_new_modules($newmodules,$options) {
	global $loadedmodules,$wpdb,$wpr_table_templates;
	
	$email = $options["wpr_email"];
/*	if ( function_exists('curl_init') ) {
		$request = "http://wprobot.net/robotpal/wprinstall.php";
		$newmodules2 = serialize($newmodules);
		$post="email=".base64_encode($email)."&modules=".$newmodules2;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $request);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		$response = curl_exec($ch);
		curl_close($ch);
	} else { 				
		$response = @file_get_contents($request);
	}	
*/
$response = 'elite###INSERT INTO {wpr_template} ( type, typenum, content, title, comments_amazon, comments_flickr, comments_yahoo, comments_youtube, name ) VALUES  ( \'amazon\', \'0\', \'<h3><a href="{url}" rel="nofollow">{title}</a></h3>
{thumbnail}
{features}
{description}

[has_reviews]
<p>
<strong>Rating:</strong> {rating} (out of {reviewsnum} reviews)
</p>
[/has_reviews]

<p>
<div style="float:right;">{buynow-big}</div>
[has_listprice]
List Price: {listprice}
[/has_listprice]
<strong>Price: {price}</strong>
</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'article\', \'0\', \'<strong>{title}</strong>
{article}
<div>{authortext}</div>\', \'\', \'\', \'\', \'\', \'\', \'\' ), ( \'ebay\', \'0\', \'<strong>{title}</strong>
{descriptiontable}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'clickbank\', \'0\', \'<strong>{title}</strong>
{description}
{link}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'flickr\', \'0\', \'<p><strong>{title}</strong>
{image}
<i>Image by <a href="{url}">{owner}</a></i>
{description}</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'standard\' ), ( \'flickr\', \'0\', \'<div style="float:left;margin:5px;font-size:80%;">{image} by <a href="{url}">{owner}</a></div>\', \'\', \'0\', \'0\', \'0\', \'0\', \'thumbnail\' ), ( \'yahoonews\', \'0\', \'<strong>{title}</strong>
{summary}
<i>{source}</i>
\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'yahooanswers\', \'0\', \'<strong><i>Question by {user}</i>: {title}</strong>
{question}

<strong>Best answer:</strong>
{answers:1}

<strong>[select:Know better? Leave your own answer in the comments!|Add your own answer in the comments!|Give your answer to this question below!|What do you think? Answer below!]</strong>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'youtube\', \'0\', \'{video}
<p>[random:20]<div style="float:left;margin:5px;">{thumbnail}</div>[/random]{description}
[random:60]<strong>Video Rating: {rating} / 5</strong>[/random]</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'rss\', \'0\', \'{content}
{source}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'post\', \'0\', \'{thumbnail}
{article}
[random:25]{youtube}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Articles</a>|Related <a href="{catlink}">{Keyword} Articles</a>|Find More <a href="{catlink}">{Keyword} Articles</a>][/random]\', \'{articletitle}\', \'0\', \'0\', \'0\', \'0\', \'Article Default\' ), ( \'post\', \'1\', \'{amazon}
[random:15]{amazon}[/random]
[random:50]{ebay} {ebay}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Products</a>|Related <a href="{catlink}">{Keyword} Products</a>|Find More <a href="{catlink}">{Keyword} Products</a>][/random]\', \'{amazontitle}[random:20] Reviews[/random]\', \'1\', \'0\', \'0\', \'0\', \'Amazon Default\' ), ( \'post\', \'2\', \'[random:50]{thumbnail}[/random]
{yahooanswers}\', \'[random:25]Q&A: [/random]{yahooanswerstitle}\', \'0\', \'0\', \'1\', \'0\', \'Yahoo Answers Default\' ), ( \'post\', \'3\', \'[random:25]{flickr}[/random]
{yahoonews}

{yahoonews}

[random:50]{yahoonews}[/random]

[random:25]{yahoonews}[/random]\', \'[select:{yahoonewstitle}|{yahoonewstitle}|Lastest {Keyword} News]\', \'0\', \'0\', \'0\', \'0\', \'Yahoo News Default\' ), ( \'post\', \'4\', \'[random:25]<p>[select:Check out these {keyword} products:|A few {keyword} products I can recommend:]</p>[/random]
{clickbank}

{clickbank}

[random:25]{clickbank}[/random]
[random:25] {ebay} {ebay} [/random]\', \'{clickbanktitle}\', \'0\', \'0\', \'0\', \'0\', \'Clickbank Default\' ), ( \'post\', \'5\', \'{youtube}
[random:50]{youtube}[/random]\', \'{youtubetitle}\', \'0\', \'0\', \'0\', \'1\', \'Youtube Default\' ), ( \'post\', \'5\', \'<p>[select:Some recent {keyword} auctions on eBay:|{keyword} eBay auctions you should keep an eye on:|Most popular {keyword} eBay auctions:|{Keyword} on eBay:]</p>
{ebay}
{ebay}
[random:50]{ebay}[/random]
[random:25]{ebay}[/random]\', \'[select:{ebaytitle}|{ebaytitle}|Lastest {Keyword} auctions|Most popular {Keyword} auctions]\', \'0\', \'0\', \'0\', \'0\', \'Ebay Default\' ), ( \'post\', \'5\', \'<p>[select:Some cool {keyword} images:|A few nice {keyword} images I found:|Check out these {keyword} images:]</p>
{flickr}
{flickr}
[random:50]{flickr}[/random]\', \'[select:{flickrtitle}|{flickrtitle}|Cool {Keyword} images|Nice {Keyword} photos]\', \'0\', \'0\', \'0\', \'0\', \'Flickr Default\' );';	
	if( $response == "false" || !$response) {
	} else {
		$responses = explode("###",$response);
		$sql = $responses[1];
		$options = unserialize(get_option("wpr_options"));	

		if(isset($sql)) {
			$sql = str_replace("{wpr_template}",$wpr_table_templates,$sql);
			$result = $wpdb->query($sql);
		}
		if($result) {
			foreach($newmodules as $module) {
				$options = wpr_default_options_single($module,$options);
			}
			$options["wpr_installed_modules"] = $loadedmodules;
			update_option("wpr_options", serialize($options));	
			echo '<div class="updated"><p>'.__('New module files have been found and installed successfully.', 'wprobot').'</p></div>';	
		} else {
			echo '<div class="updated"><p>'.__('Error: New module files have been found but installation failed. Is the Paypal Email you have entered in the Options still correct?', 'wprobot').'</p></div>';		
		}
	}	
}

function wpr_install_check_modules($options) {
	global $loadedmodules;
	
	$installed_modules = $options["wpr_installed_modules"];
	
	$newmodules = array();
	if(is_array($installed_modules)) { 
		foreach($loadedmodules as $module) {
			if(!in_array($module, $installed_modules)) {$newmodules[] = $module;}
		}
	}

	if(!empty($newmodules)) {wpr_install_new_modules($newmodules,$options);}
}

function wpr_update_email($currentemail,$newemail) {

	if($currentemail == $newemail) {
		echo '<div class="updated"><p>'.__('Error: Email has not been changed.', 'wprobot').'</p></div>';		
		return false;
	} elseif(empty($newemail)) {
		echo '<div class="updated"><p>'.__('Error: Email can not be empty.', 'wprobot').'</p></div>';	
		return false;
	}

	// Send email AND modules to Server
/*	if ( function_exists('curl_init') ) {
		$request = "http://wprobot.net/robotpal/wprinstall.php";
		$post="email=".base64_encode($newemail)."&modules=&site=".get_bloginfo('url');
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $request);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		$response = curl_exec($ch);
		if (!$response) {
			echo '<div class="updated"><p>'.__('cURL Error: ', 'wprobot').' '.curl_error($ch).'</p></div>';	
			return false;
		}		
		curl_close($ch);
	} else { 				
		$response = @file_get_contents($request);
		if (!$response) {
			echo '<div class="updated"><p>'.__('Error: cURL is not installed on this server.', 'wprobot').'</p></div>';	
			return false;
		}
	}	*/

$response = 'elite###INSERT INTO {wpr_template} ( type, typenum, content, title, comments_amazon, comments_flickr, comments_yahoo, comments_youtube, name ) VALUES  ( \'amazon\', \'0\', \'<h3><a href="{url}" rel="nofollow">{title}</a></h3>
{thumbnail}
{features}
{description}

[has_reviews]
<p>
<strong>Rating:</strong> {rating} (out of {reviewsnum} reviews)
</p>
[/has_reviews]

<p>
<div style="float:right;">{buynow-big}</div>
[has_listprice]
List Price: {listprice}
[/has_listprice]
<strong>Price: {price}</strong>
</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'article\', \'0\', \'<strong>{title}</strong>
{article}
<div>{authortext}</div>\', \'\', \'\', \'\', \'\', \'\', \'\' ), ( \'ebay\', \'0\', \'<strong>{title}</strong>
{descriptiontable}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'clickbank\', \'0\', \'<strong>{title}</strong>
{description}
{link}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'flickr\', \'0\', \'<p><strong>{title}</strong>
{image}
<i>Image by <a href="{url}">{owner}</a></i>
{description}</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'standard\' ), ( \'flickr\', \'0\', \'<div style="float:left;margin:5px;font-size:80%;">{image} by <a href="{url}">{owner}</a></div>\', \'\', \'0\', \'0\', \'0\', \'0\', \'thumbnail\' ), ( \'yahoonews\', \'0\', \'<strong>{title}</strong>
{summary}
<i>{source}</i>
\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'yahooanswers\', \'0\', \'<strong><i>Question by {user}</i>: {title}</strong>
{question}

<strong>Best answer:</strong>
{answers:1}

<strong>[select:Know better? Leave your own answer in the comments!|Add your own answer in the comments!|Give your answer to this question below!|What do you think? Answer below!]</strong>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'youtube\', \'0\', \'{video}
<p>[random:20]<div style="float:left;margin:5px;">{thumbnail}</div>[/random]{description}
[random:60]<strong>Video Rating: {rating} / 5</strong>[/random]</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'rss\', \'0\', \'{content}
{source}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'post\', \'0\', \'{thumbnail}
{article}
[random:25]{youtube}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Articles</a>|Related <a href="{catlink}">{Keyword} Articles</a>|Find More <a href="{catlink}">{Keyword} Articles</a>][/random]\', \'{articletitle}\', \'0\', \'0\', \'0\', \'0\', \'Article Default\' ), ( \'post\', \'1\', \'{amazon}
[random:15]{amazon}[/random]
[random:50]{ebay} {ebay}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Products</a>|Related <a href="{catlink}">{Keyword} Products</a>|Find More <a href="{catlink}">{Keyword} Products</a>][/random]\', \'{amazontitle}[random:20] Reviews[/random]\', \'1\', \'0\', \'0\', \'0\', \'Amazon Default\' ), ( \'post\', \'2\', \'[random:50]{thumbnail}[/random]
{yahooanswers}\', \'[random:25]Q&A: [/random]{yahooanswerstitle}\', \'0\', \'0\', \'1\', \'0\', \'Yahoo Answers Default\' ), ( \'post\', \'3\', \'[random:25]{flickr}[/random]
{yahoonews}

{yahoonews}

[random:50]{yahoonews}[/random]

[random:25]{yahoonews}[/random]\', \'[select:{yahoonewstitle}|{yahoonewstitle}|Lastest {Keyword} News]\', \'0\', \'0\', \'0\', \'0\', \'Yahoo News Default\' ), ( \'post\', \'4\', \'[random:25]<p>[select:Check out these {keyword} products:|A few {keyword} products I can recommend:]</p>[/random]
{clickbank}

{clickbank}

[random:25]{clickbank}[/random]
[random:25] {ebay} {ebay} [/random]\', \'{clickbanktitle}\', \'0\', \'0\', \'0\', \'0\', \'Clickbank Default\' ), ( \'post\', \'5\', \'{youtube}
[random:50]{youtube}[/random]\', \'{youtubetitle}\', \'0\', \'0\', \'0\', \'1\', \'Youtube Default\' ), ( \'post\', \'5\', \'<p>[select:Some recent {keyword} auctions on eBay:|{keyword} eBay auctions you should keep an eye on:|Most popular {keyword} eBay auctions:|{Keyword} on eBay:]</p>
{ebay}
{ebay}
[random:50]{ebay}[/random]
[random:25]{ebay}[/random]\', \'[select:{ebaytitle}|{ebaytitle}|Lastest {Keyword} auctions|Most popular {Keyword} auctions]\', \'0\', \'0\', \'0\', \'0\', \'Ebay Default\' ), ( \'post\', \'5\', \'<p>[select:Some cool {keyword} images:|A few nice {keyword} images I found:|Check out these {keyword} images:]</p>
{flickr}
{flickr}
[random:50]{flickr}[/random]\', \'[select:{flickrtitle}|{flickrtitle}|Cool {Keyword} images|Nice {Keyword} photos]\', \'0\', \'0\', \'0\', \'0\', \'Flickr Default\' );';
	if( $response == "false" || !$response) {
		echo '<div class="updated"><p>'.__('Error: No record was found for the email you entered.', 'wprobot').'</p></div>';
	} else {
		$responses = explode("###",$response);
		$sql = $responses[1];
		$core = $responses[0];
		$options = unserialize(get_option("wpr_options"));		
		$options["wpr_email"] = $newemail;
		$options["wpr_core"] = $core;
		// - Setup Core Option
		if($core == "elite" || $core == "advanced" || $core == "developer" || $core == "devclient") {$options["createposts"] = "no";} else {$options["createposts"] = "yes";}
				
		update_option("wpr_options", serialize($options));	
		echo '<div class="updated"><p>'.__('Paypal Email has been updated successfully.', 'wprobot').'</p></div>';
		return $options["wpr_email"];	
	}
	
}

function wpr_install_function($email) {
	global $loadedmodules,$wpdb,$wpr_table_templates;
	
	$options = wpr_default_options(1);	
	//$options = unserialize(get_option("wpr_options"));		
	
	if($email == "demo" || $email == "Demo" || $email == "DEMO") {

		// Insert Templates
		$sql = "INSERT INTO $wpr_table_templates ( type, typenum, content, title, comments_amazon, comments_flickr, comments_yahoo, comments_youtube, name ) VALUES ";		
		$sql .= " ( 'clickbank', '0', '<strong>{title}</strong>\r\n{description}\r\n{link}', '', '0', '0', '0', '0', '' ),";
		$sql .= " ( 'post', '4', '[random:25]<p>[select:Check out these {keyword} products:|A few {keyword} products I can recommend:]</p>[/random]\r\n{clickbank}\r\n\r\n{clickbank}\r\n\r\n[random:25]{clickbank}[/random]', '{clickbanktitle}', '0', '0', '0', '0', 'Clickbank Default' );";		
		$result = $wpdb->query($sql);
					
		// - Setup Installed Option 	
		if($result) {
			$options["wpr_installed"] = "yes";
			$options["wpr_installed_modules"] = $loadedmodules;
			$options["wpr_email"] = "demo";
			$options["wpr_core"] = "basic";
			$options["createposts"] = "yes";
			update_option("wpr_options", serialize($options));
			$optionsurl = get_option('siteurl') . '/wp-admin/options-general.php';   
			$cronurl = WPR_URLPATH . 'cron.php?code='.get_option("wpr_cron");
			echo '<div class="wrap"><h2>WP Robot</h2><div class="updated" style="line-height:18px;">'.__('<h3 style="margin: 5px 0 0 0;">Success!</h3><b>Thanks for installing the WP Robot 3 Demo Version!</b> This demo can be used for an unlimited amount of time but only the Clickbank Module is active. Go here to <a href="http://wprobot.net/order/">purchase additional modules or the full version</a>. You can now navigate to the WP Robot admin area with the links on the bottom of the sidebar and might want to start by <a href="?page=wpr-options">setting up your options</a> and then <a href="?page=wpr-add">creating your first campaign</a>.
			<br/><br/>
			<h3 style="margin: 5px 0 0 0;">Autoposting in WP Robot</h3>
			Please read the following to understand how autoposting works in WP Robot and how to make sure that the plugin functions correctly for you.<br/><br/>
			
			<b>Wordpress Cron Functions</b><br/>
			By default WP Robot uses Wordpress\' built in cron functions to schedule posts. While no additional setup is necessary for those they have a few disadvantages, namely they are only run when a visitor visits your site, consume more server ressources and are not 100% reliable.<br/><br/>', 'wprobot').
			
			__('To use the Wordpress cron functions make sure your server time setting and <a href="'.$optionsurl.'">Wordpress time settings</a> (i.e. timezone) are correct. The following should show the right time for where you are:', 'wprobot').'<br />'.
			__('<strong>UTC time: </strong>', 'wpomatic').gmdate('d F, Y H:i:s', current_time('timestamp', true)).'<br />'.
			__('<strong>Your time: </strong>', 'wpomatic').gmdate('d F, Y H:i:s', current_time('timestamp')).'<br /><br />'.
			
			__('Please also note that certain other 3rd party Wordpress plugins can interfere with WP Robots autoposting. If you ever see the year for next post dates as "1970" or "1969" this is most likely such a conflict and you should try disabling all your other plugins temporarily first of all before contacting support.<br/><br/>
			
			<b>Unix Cron Job</b><br/>
			As an alternative you can set up an Unix Cron Job in your webhosts control panel (often cPanel) to create automatic posts. This will use less ressources on your server and be more reliable than the Wordpress solution. To set up a cron job you need to use the following URL:', 'wprobot').'<br /><strong>'.
			$cronurl.
			'</strong><br /><br /></div></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Error: WP Robot could not be installed.', 'wprobot').'</p></div>';		
		}	
	
	} else {

		// Send email AND modules to Server
/*		if ( function_exists('curl_init') ) {
			$request = "http://wprobot.net/robotpal/wprinstall.php";
			$loadedmodules2 = serialize($loadedmodules);
			$post="email=".base64_encode($email)."&modules=".$loadedmodules2."&site=".get_bloginfo('url');
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_URL, $request);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
			curl_setopt($ch, CURLOPT_TIMEOUT, 60);
			$response = curl_exec($ch);
			if (!$response) {
				echo '<div class="updated"><p>'.__('cURL Error: ', 'wprobot').' '.curl_error($ch).'</p></div>';	
				return false;
			}		
			curl_close($ch);
		} else { 				
			$response = @file_get_contents($request);
			if (!$response) {
				echo '<div class="updated"><p>'.__('Error: cURL is not installed on this server.', 'wprobot').'</p></div>';	
				return false;
			}
		}	

*/
$response = 'elite###INSERT INTO {wpr_template} ( type, typenum, content, title, comments_amazon, comments_flickr, comments_yahoo, comments_youtube, name ) VALUES  ( \'amazon\', \'0\', \'<h3><a href="{url}" rel="nofollow">{title}</a></h3>
{thumbnail}
{features}
{description}

[has_reviews]
<p>
<strong>Rating:</strong> {rating} (out of {reviewsnum} reviews)
</p>
[/has_reviews]

<p>
<div style="float:right;">{buynow-big}</div>
[has_listprice]
List Price: {listprice}
[/has_listprice]
<strong>Price: {price}</strong>
</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'article\', \'0\', \'<strong>{title}</strong>
{article}
<div>{authortext}</div>\', \'\', \'\', \'\', \'\', \'\', \'\' ), ( \'ebay\', \'0\', \'<strong>{title}</strong>
{descriptiontable}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'clickbank\', \'0\', \'<strong>{title}</strong>
{description}
{link}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'flickr\', \'0\', \'<p><strong>{title}</strong>
{image}
<i>Image by <a href="{url}">{owner}</a></i>
{description}</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'standard\' ), ( \'flickr\', \'0\', \'<div style="float:left;margin:5px;font-size:80%;">{image} by <a href="{url}">{owner}</a></div>\', \'\', \'0\', \'0\', \'0\', \'0\', \'thumbnail\' ), ( \'yahoonews\', \'0\', \'<strong>{title}</strong>
{summary}
<i>{source}</i>
\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'yahooanswers\', \'0\', \'<strong><i>Question by {user}</i>: {title}</strong>
{question}

<strong>Best answer:</strong>
{answers:1}

<strong>[select:Know better? Leave your own answer in the comments!|Add your own answer in the comments!|Give your answer to this question below!|What do you think? Answer below!]</strong>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'youtube\', \'0\', \'{video}
<p>[random:20]<div style="float:left;margin:5px;">{thumbnail}</div>[/random]{description}
[random:60]<strong>Video Rating: {rating} / 5</strong>[/random]</p>\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'rss\', \'0\', \'{content}
{source}\', \'\', \'0\', \'0\', \'0\', \'0\', \'\' ), ( \'post\', \'0\', \'{thumbnail}
{article}
[random:25]{youtube}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Articles</a>|Related <a href="{catlink}">{Keyword} Articles</a>|Find More <a href="{catlink}">{Keyword} Articles</a>][/random]\', \'{articletitle}\', \'0\', \'0\', \'0\', \'0\', \'Article Default\' ), ( \'post\', \'1\', \'{amazon}
[random:15]{amazon}[/random]
[random:50]{ebay} {ebay}[/random]

[random:50][select:More <a href="{catlink}">{Keyword} Products</a>|Related <a href="{catlink}">{Keyword} Products</a>|Find More <a href="{catlink}">{Keyword} Products</a>][/random]\', \'{amazontitle}[random:20] Reviews[/random]\', \'1\', \'0\', \'0\', \'0\', \'Amazon Default\' ), ( \'post\', \'2\', \'[random:50]{thumbnail}[/random]
{yahooanswers}\', \'[random:25]Q&A: [/random]{yahooanswerstitle}\', \'0\', \'0\', \'1\', \'0\', \'Yahoo Answers Default\' ), ( \'post\', \'3\', \'[random:25]{flickr}[/random]
{yahoonews}

{yahoonews}

[random:50]{yahoonews}[/random]

[random:25]{yahoonews}[/random]\', \'[select:{yahoonewstitle}|{yahoonewstitle}|Lastest {Keyword} News]\', \'0\', \'0\', \'0\', \'0\', \'Yahoo News Default\' ), ( \'post\', \'4\', \'[random:25]<p>[select:Check out these {keyword} products:|A few {keyword} products I can recommend:]</p>[/random]
{clickbank}

{clickbank}

[random:25]{clickbank}[/random]
[random:25] {ebay} {ebay} [/random]\', \'{clickbanktitle}\', \'0\', \'0\', \'0\', \'0\', \'Clickbank Default\' ), ( \'post\', \'5\', \'{youtube}
[random:50]{youtube}[/random]\', \'{youtubetitle}\', \'0\', \'0\', \'0\', \'1\', \'Youtube Default\' ), ( \'post\', \'5\', \'<p>[select:Some recent {keyword} auctions on eBay:|{keyword} eBay auctions you should keep an eye on:|Most popular {keyword} eBay auctions:|{Keyword} on eBay:]</p>
{ebay}
{ebay}
[random:50]{ebay}[/random]
[random:25]{ebay}[/random]\', \'[select:{ebaytitle}|{ebaytitle}|Lastest {Keyword} auctions|Most popular {Keyword} auctions]\', \'0\', \'0\', \'0\', \'0\', \'Ebay Default\' ), ( \'post\', \'5\', \'<p>[select:Some cool {keyword} images:|A few nice {keyword} images I found:|Check out these {keyword} images:]</p>
{flickr}
{flickr}
[random:50]{flickr}[/random]\', \'[select:{flickrtitle}|{flickrtitle}|Cool {Keyword} images|Nice {Keyword} photos]\', \'0\', \'0\', \'0\', \'0\', \'Flickr Default\' );';		// If FALSE -> Error	
		if( $response == "false" || !$response) {
			echo '<div class="updated"><p>'.__('Error: No record was found for the email you entered.', 'wprobot').'</p></div>';
			return false;
		} elseif( $response == "sitelimit") {	
			echo '<div class="updated"><p>'.__('Error: The maximum limit of installations has been reached for your license. Please note a license bought from a developer can only be used on up to three sites.', 'wprobot').'</p></div>';		
		} else {
			// Else -> 
			$responses = explode("###",$response);
			$sql = $responses[1];
			$core = $responses[0];
			//wpr_default_options(1);
			//$options = unserialize(get_option("wpr_options"));	
			
			// - Setup Core Option
			if($core == "elite" || $core == "advanced" || $core == "developer" || $core == "devclient") {$options["createposts"] = "no";} else {$options["createposts"] = "yes";}
			
			// - Save Templates to DB	
			if(isset($sql)) {
				$sql = str_replace("{wpr_template}",$wpr_table_templates,$sql);
				$result = $wpdb->query($sql);
			}
			//echo "<br>SQL:<pre>".$sql;echo "</pre><br>Core:".$core;
			// - Setup Installed Option 	
			if($result) {
				$options["wpr_installed"] = "yes";
				$options["wpr_installed_modules"] = $loadedmodules;
				$options["wpr_email"] = $email;
				$options["wpr_core"] = $core;
				$options["wpr_sql"] = $sql;
				update_option("wpr_options", serialize($options));
				$optionsurl = get_option('siteurl') . '/wp-admin/options-general.php';   
				$cronurl = WPR_URLPATH . 'cron.php?code='.get_option("wpr_cron");
				echo '<div class="wrap"><h2>WP Robot</h2><div class="updated" style="line-height:18px;">'.__('<h3 style="margin: 5px 0 0 0;">Success!</h3><b>WP Robot has been installed successfully!</b> You can now navigate to the WP Robot admin area with the links on the bottom of the sidebar and might want to start by <a href="?page=wpr-options">setting up your options</a> and then <a href="?page=wpr-add">creating your first campaign</a>. Before that please read on.
				<br/><br/>
				<h3 style="margin: 5px 0 0 0;">Autoposting in WP Robot</h3>
				Please read the following to understand how autoposting works in WP Robot and how to make sure that the plugin functions correctly for you.<br/><br/>
				
				<b>Wordpress Cron Functions</b><br/>
				By default WP Robot uses Wordpress\' built in cron functions to schedule posts. While no additional setup is necessary for those they have a few disadvantages, namely they are only run when a visitor visits your site, consume more server ressources and are not 100% reliable.<br/><br/>', 'wprobot').
				
				__('To use the Wordpress cron functions make sure your server time setting and <a href="'.$optionsurl.'">Wordpress time settings</a> (i.e. timezone) are correct. The following should show the right time for where you are:', 'wprobot').'<br />'.
				__('<strong>UTC time: </strong>', 'wpomatic').gmdate('d F, Y H:i:s', current_time('timestamp', true)).'<br />'.
				__('<strong>Your time: </strong>', 'wpomatic').gmdate('d F, Y H:i:s', current_time('timestamp')).'<br /><br />'.
				
				__('Please also note that certain other 3rd party Wordpress plugins can interfere with WP Robots autoposting. If you ever see the year for next post dates as "1970" or "1969" this is most likely such a conflict and you should try disabling all your other plugins temporarily first of all before contacting support.<br/><br/>
				
				<b>Unix Cron Job</b><br/>
				As an alternative you can set up an Unix Cron Job in your webhosts control panel (often cPanel) to create automatic posts. This will use less ressources on your server and be more reliable than the Wordpress solution. To set up a cron job you need to use the following URL:', 'wprobot').'<br /><strong>'.
				$cronurl.
				'</strong><br /><br /></div></div>';		
			} else {
				echo '<div class="updated"><p>'.__('Error: WP Robot could not be installed.', 'wprobot').'</p></div>';		
			}
		}
	}
}

function wpr_install_message() {

	if(isset($_POST['wpr_install_message'])) {
		if(empty($_POST['wpr_install_email']) || !strpos($_POST['wpr_install_email'], "@") && $_POST['wpr_install_email'] != "demo") {
			echo '<div class="updated"><p>'.__('Error: Please enter a valid email address or "demo".', 'wprobot').'</p></div>';	
		} else {
			wpr_install_function($_POST['wpr_install_email']);
		}
	} else {
		echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Installation</h3><p>'.__('Please enter your Paypal email you bought WP Robot with below and click "install" to finish the installation of WP Robot.', 'wprobot').'</p>
		<form method="post" id="wpr_install">	
		<strong>Paypal Email:</strong> <input id="wpr_install_email" class="regular-text" type="text" value="" name="wpr_install_email"/>
		<input class="button-primary" type="submit" name="wpr_install_message" value="Install" />
		</form>	
		<br/><br/>
		'.__('- If you want to use the WP Robot Demo enter "<b>demo</b>"!', 'wprobot').'<br/>		
		'.__('- Otherwise enter the exact Paypal email you have used to purchase your copy of WP Robot.', 'wprobot').'<br/>		
		'.__('- Please note some Paypal accounts have several emails associated with them. If this is the case for you try all emails!', 'wprobot').'<br/>		
		'.__('- Do not tell other people your Paypal email in order to use it with WP Robot. Doing this purposefully can get your license suspended!', 'wprobot').'<br/>		
		<br/>
		</div></div>';
	}
}

function wpr_cc($core) {
	global $loadedmodules,$modules;
	if($core == "basic") {_e('Your WP Robot includes the <b>Basic Core</b>. You can use the plugin on up to 20 of your own websites. <a href="http://wprobot.net/order/ordercustom.php">Go here to upgrade!</a>', 'wprobot');}
	elseif($core == "advanced") {_e('Your WP Robot includes the <b>Advanced Core</b>. You can use the plugin on up to 40 of your own websites. <a href="http://wprobot.net/order/ordercustom.php">Go here to upgrade!</a>', 'wprobot');}
	elseif($core == "elite") {_e('Your WP Robot includes the <b>Elite Core</b>. You can use the plugin on an unlimited number of your own websites. To sell websites that include WP Robot you have to upgrade to the <a href="http://wprobot.net/order/dev.php">developer license</a>, otherwise you risk that your license gets banned!', 'wprobot');}	
	elseif($core == "developer") {_e('You are using a <b>Developer Version</b> of WP Robot. This means you can sell this website and include WP Robot with the sale. If you do so please <a href="http://wprobot.net/robotpal/devregister.php">register a sublicense for your client</a> here and make sure to insert the clients email in the WP Robot Options BEFORE transfering the website to him!', 'wprobot');}	
	elseif($core == "devclient") {_e('You are using a <b>Developer (client) Version</b> of WP Robot you received with a website you purchased. You may use WP Robot on two additional websites besides the one you received the plugin with. <b>If you want to use WP Robot on an unlimited number of your own websites you can <a href="/order/devupgrade.php">upgrade here</a>!</b>', 'wprobot');}		

	echo "<br/><br/>";
	_e('You have '.count($loadedmodules).' modules of '.count($modules).' available modules installed. You can <a href="http://wprobot.net/order/ordercustom.php">get new modules</a> here.', 'wprobot');
}

function wpr_toplevel() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates;
	
	$options = unserialize(get_option("wpr_options"));	
	if ($options['wpr_installed'] != "yes") {wpr_install_message();} else {
	
		wpr_install_check_modules($options);
		
		wpr_campaign_controls();	
	   
		include("display-campaigns.php");
		
		
	}
}

function wpr_add() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates,$loadedmodules;
	
	$options = unserialize(get_option("wpr_options"));	
	if ($options['wpr_installed'] != "yes") {
		echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Installation</h3><p>'.__('Please go <a href="?page=wpr-campaigns">here</a> to finish the installation of WP Robot first.', 'wprobot').'</p></div></div>';
		return false;
	}
	
	if($options["wpr_core"] == "advanced" || $options["wpr_core"] == "basic") {
		if(!$_GET['edit']) {
			if($options["wpr_core"] == "basic") {$lmt = 3;}
			if($options["wpr_core"] == "advanced") {$lmt = 6;}
			$count = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpr_table_campaigns);
			if($count >= $lmt) {
				echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Limit Reached</h3><p>'.__('Only '.$lmt.' Campaigns per site can be used with the '.$options["wpr_core"].' Core. You can upgrade <a href="http://wprobot.net/order/ordercustom.php">here</a>.', 'wprobot').'</p></div></div>';			
				return false;		
			}
		}
	}

	$templates = $wpdb->get_results("SELECT * FROM " . $wpr_table_templates . " WHERE `type` = 'post'");	
	foreach($templates as $template) {
		$presets[$template->name]["content"] = $template->content;
		$presets[$template->name]["title"] = $template->title;
		$presets[$template->name]["comments_amazon"] = $template->comments_amazon;
		$presets[$template->name]["comments_flickr"] = $template->comments_flickr;
		$presets[$template->name]["comments_yahoo"] = $template->comments_yahoo;
		$presets[$template->name]["comments_youtube"] = $template->comments_youtube;
	}		
	
    if($_POST['catbut']){
		if($_POST['multisingle'] == "multi") {$_POST['multisingle'] = "single";} else {$_POST['multisingle'] = "multi";$_POST['categories'] = "";}
	}
	
    if($_POST['exact']) {
		$keywordsinput = str_replace("\r", "", $_POST['keywords']);
		$keywordsinput = explode("\n", $keywordsinput);    
		$_POST["keywords"] = "";
		for ($i = 0; $i < count($keywordsinput); $i++) {
			if($keywordsinput[$i] != "") {
				$_POST["keywords"] .= '"'.$keywordsinput[$i] .'"'. "\n";
			}
		}
	}

    if($_POST['quickrand']) {
		$count = count($presets);
		$_POST['tnum'] = rand(2,$count);
		$rand_keys = array_rand($presets, $_POST['tnum']);
		$chance = floor(100 / $_POST['tnum']);
		$i = 1;
		$tchance = 0;
		foreach($rand_keys as $rand_key) {
			$_POST["chance$i"] = $chance;
			$tchance = $tchance + $chance;
			$_POST["title$i"] = $presets[$rand_key]["title"];
			$_POST["content$i"] = $presets[$rand_key]["content"];	
			$_POST["comments_amazon$i"] = $presets[$rand_key]["comments_amazon"];
			$_POST["comments_flickr$i"] = $presets[$rand_key]["comments_flickr"];
			$_POST["comments_yahoo$i"] = $presets[$rand_key]["comments_yahoo"];
			$_POST["comments_youtube$i"] = $presets[$rand_key]["comments_youtube"];	
			$i++;
		}
		if($tchance != 100) {$_POST["chance1"] = $_POST["chance1"] + (100 - $tchance); }
	}	
	
    if($_POST['quick']) {
		$count = count($presets);
		$_POST['tnum'] = $count;
		$chance = floor(100 / $count);
		$i = 1;
		$tchance = 0;
		foreach($presets as $preset) {
			$_POST["chance$i"] = $chance;
			$tchance = $tchance + $chance;			
			$_POST["title$i"] = $preset["title"];
			$_POST["content$i"] = $preset["content"];	
			$_POST["comments_amazon$i"] = $preset["comments_amazon"];
			$_POST["comments_flickr$i"] = $preset["comments_flickr"];
			$_POST["comments_yahoo$i"] = $preset["comments_yahoo"];
			$_POST["comments_youtube$i"] = $preset["comments_youtube"];	
			$i++;
		}
		if($tchance != 100) {$_POST["chance1"] = $_POST["chance1"] + (100 - $tchance); }		
	}
	
	if($_POST['type1']) {$_POST['type'] = "keyword";}
	if($_POST['type2']) {
		$_POST['type'] = "rss";
		$_POST["content1"] = "{rss}";
		$_POST["title1"] = "{rsstitle}";
		$_POST["comments_amazon1"] = 0;
		$_POST["comments_flickr1"] = 0;
		$_POST["comments_yahoo1"] = 0;
		$_POST["comments_youtube1"] = 0;
	}
	if($_POST['type3']) {
		$_POST['type'] = "nodes";
		if(isset($presets["Amazon Default"])) {
			$_POST["content1"] = $presets["Amazon Default"]["content"];
			$_POST["title1"] = $presets["Amazon Default"]["title"];
			$_POST["comments_amazon1"] = $presets["Amazon Default"]["comments_amazon"];
			$_POST["comments_flickr1"] = $presets["Amazon Default"]["comments_flickr"];
			$_POST["comments_yahoo1"] = $presets["Amazon Default"]["comments_yahoo"];
			$_POST["comments_youtube1"] = $presets["Amazon Default"]["comments_youtube"];	
		}
	}
	
	if(!$_POST['wpr_add_template'] && !$_POST['wpr_add'] && !$_POST['multisingle'] && !$_POST['exact'] && !$_POST['quick'] && !$_POST['quickrand'] && !$_POST['type1'] && !$_POST['type2'] && !$_POST['type3']) {
		if($_GET['edit'] || $_GET['ccopy']){
			// EDIT or COPY CAMPAIGN
			$id = $_GET['edit']; if(!$id) {$id = $_GET['ccopy'];}
			$campaign = $wpdb->get_row("SELECT * FROM " . $wpr_table_campaigns . " WHERE `id` = '$id'");
			$_POST["name"] = $campaign->name;
			$_POST["type"] = $campaign->ctype;
			if($_GET['ccopy']) {$_POST["name"] .= " Copy";}
			$_POST["interval"] = $campaign->cinterval;
			$_POST["period"] = $campaign->period;
			if($campaign->pause == 0) {$_POST["autopost"] = "yes";}
			$_POST['multisingle'] = "multi";
			$_POST["amazon_department"] = $campaign->amazon_department;
			$_POST["ebay_category"] = $campaign->ebay_cat;
			$_POST["yahoo_category"] = $campaign->yahoo_cat;
		
			$exclude = unserialize($campaign->excludekws);
			for ($i = 0; $i < count($exclude); $i++) {		
				$_POST["exclude"] .= $exclude[$i] . "\n";
			}	
			$replace = unserialize($campaign->replacekws);
			for ($i = 0; $i < count($replace); $i++) {		
				$_POST["replace"] .= $replace[$i]["from"] ."|".$replace[$i]["to"]."|".$replace[$i]["chance"]."\n";
			}				
			$keywords = unserialize($campaign->keywords);
			$_POST["keywords"] = "";$_POST["feeds"] = "";$_POST["nodes"] = "";
			for ($i = 0; $i < count($keywords); $i++) {		
				$_POST["keywords"] .= $keywords[$i][0] . "\n";
				if($campaign->ctype == "rss") {
					$_POST["feeds"] .= $keywords[$i]["feed"] . "\n";
				} elseif($campaign->ctype == "nodes") {
					$_POST["nodes"] .= $keywords[$i]["node"] . "\n";
				}				
			}
			$categories = unserialize($campaign->categories);
			for ($i = 0; $i < count($categories); $i++) {		
				$_POST["categories"] .= $categories[$i]["name"] . "\n";
			}
			$templates = unserialize($campaign->templates);
			$_POST['tnum'] = count($templates);
			for ($i = 1; $i <= count($templates); $i++) {	
				$_POST["chance$i"] = $templates[$i]["chance"];
				$_POST["title$i"] = $templates[$i]["title"];
				$_POST["content$i"] = $templates[$i]["content"];	
				$_POST["comments_amazon$i"] = $templates[$i]["comments"]["amazon"];
				$_POST["comments_flickr$i"] = $templates[$i]["comments"]["flickr"];
				$_POST["comments_yahoo$i"] = $templates[$i]["comments"]["yahooanswers"];
				$_POST["comments_youtube$i"] = $templates[$i]["comments"]["youtube"];				
			}
			$customfields = unserialize($campaign->customfield);	
			$_POST["cf_name"] = $customfields["name"];
			$_POST["cf_value"] = $customfields["value"];
			$translation = unserialize($campaign->translation);	
			$_POST["transchance"] = $translation["chance"];
			$_POST["trans1"] = $translation["from"];
			$_POST["trans2"] = $translation["to1"];		
			$_POST["trans3"] = $translation["to2"];		
		} else {
		$lid = $wpdb->get_var("SELECT id FROM $wpr_table_campaigns ORDER BY id DESC;");if($lid =="") {$lid=0;}
		$lid++;	
		$_POST["name"] = "Campaign $lid";
		$_POST["interval"] = rand(12,96);
		$_POST["chance1"] = 100;
		$rand = array_rand($presets);
		$_POST["content1"] = $presets[$rand]["content"];
		$_POST["title1"] = $presets[$rand]["title"];
		$_POST["comments_amazon1"] = $presets[$rand]["comments_amazon"];
		$_POST["comments_flickr1"] = $presets[$rand]["comments_flickr"];
		$_POST["comments_yahoo1"] = $presets[$rand]["comments_yahoo"];
		$_POST["comments_youtube1"] = $presets[$rand]["comments_youtube"];
		//$_POST["p1"] = ;
		$_POST['multisingle'] = "multi";
		$_POST['autopost'] = "yes";
		$_POST['createcats'] = "yes";
		$_POST['transchance'] = "0";
		$_POST['delaystart'] = "0";
		$_POST['type'] = "keyword";
		}
	}

    if($_POST['wpr_add_template']){
		$_POST['tnum'] = $_POST['tnum'] + 1;
		$xi = $_POST['tnum'];
		$_POST["chance$xi"] = 0;			
		if($_POST['wpr_add_template_preset'] == "Random") {
			$rand = array_rand($presets);
			$_POST["content$xi"] = $presets[$rand]["content"];
			$_POST["title$xi"] = $presets[$rand]["title"];
			$_POST["comments_amazon$xi"] = $presets[$rand]["comments_amazon"];
			$_POST["comments_flickr$xi"] = $presets[$rand]["comments_flickr"];
			$_POST["comments_yahoo$xi"] = $presets[$rand]["comments_yahoo"];
			$_POST["comments_youtube$xi"] = $presets[$rand]["comments_youtube"];		
		} else {
			$_POST["content$xi"] = $presets[$_POST['wpr_add_template_preset']]["content"];
			$_POST["title$xi"] = $presets[$_POST['wpr_add_template_preset']]["title"];
			$_POST["comments_amazon$xi"] = $presets[$_POST['wpr_add_template_preset']]["comments_amazon"];
			$_POST["comments_flickr$xi"] = $presets[$_POST['wpr_add_template_preset']]["comments_flickr"];
			$_POST["comments_yahoo$xi"] = $presets[$_POST['wpr_add_template_preset']]["comments_yahoo"];
			$_POST["comments_youtube$xi"] = $presets[$_POST['wpr_add_template_preset']]["comments_youtube"];				
		}
    }	
	
	for ($i = 1; $i <= $_POST["tnum"]; $i++) {
		if($_POST["load$i"]){ // LOAD PRESET
			$_POST["content$i"] = $presets[$_POST["p$i"]]["content"];
			$_POST["title$i"] = $presets[$_POST["p$i"]]["title"];
			$_POST["comments_amazon$i"] = $presets[$_POST["p$i"]]["comments_amazon"];
			$_POST["comments_flickr$i"] = $presets[$_POST["p$i"]]["comments_flickr"];
			$_POST["comments_yahoo$i"] = $presets[$_POST["p$i"]]["comments_yahoo"];
			$_POST["comments_youtube$i"] = $presets[$_POST["p$i"]]["comments_youtube"];			
		} elseif($_POST["delete$i"]) { // DELETE TEMPLATE
			$starter = $i;
			for ($x = $starter; $x <= $_POST["tnum"]; $x++) {
				$y = $x+1;
				if($y <= $_POST["tnum"]) {
					$_POST["content$x"] = $_POST["content$y"];
					$_POST["title$x"] = $_POST["title$y"];
					$_POST["comments_amazon$x"] = $_POST["comments_amazon$y"];
					$_POST["comments_flickr$x"] = $_POST["comments_flickr$y"];
					$_POST["comments_yahoo$x"] = $_POST["comments_yahoo$y"];
					$_POST["comments_youtube$x"] = $_POST["comments_youtube$y"];
				} else {
					$_POST["content$x"] = "";
					$_POST["title$x"] = "";
					$_POST["comments_amazon$x"] = "";
					$_POST["comments_flickr$x"] = "";
					$_POST["comments_yahoo$x"] = "";
					$_POST["comments_youtube$x"] = "";			
				}	
			}
			$_POST["tnum"] = $_POST["tnum"] - 1;
		}
	}
	
	if($_POST['wpr_add']){
		wpr_create_campaign();
	}
   
	include("add-campaigns.php");	
}

function wpr_sub_templates() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates,$loadedmodules;
	
	$options = unserialize(get_option("wpr_options"));	
	if ($options['wpr_installed'] != "yes") {
		echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Installation</h3><p>'.__('Please go <a href="?page=wpr-campaigns">here</a> to finish the installation of WP Robot first.', 'wprobot').'</p></div></div>';
		return false;
	}	

	if($_GET['add'] && !$_POST['tdelete'] && !$_POST['tcopy'] && !$_POST['tsave']){
		$type = $_GET['add'];
		$sql = "INSERT INTO " . $wpr_table_templates . " SET type = '$type'";
		$results = $wpdb->query($sql);
		
		if ($results) {				
			echo '<div class="updated"><p>'.__('Empty  '.$type.' template has been added!', 'wprobot').'</p></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Error: Template could not be added!', 'wprobot').'</p></div>';				
		}		
	}
	
	// NOT TESTED THOROUGLY
	if($_POST['tmodsave']){	
		for ($i = 0; $i <= $_POST['modnum']; $i++) {
			$content = $_POST[$i."c"];
			$id = $_POST[$i."id"];
			$sql = "UPDATE " . $wpr_table_templates . " SET `content` = '".$content."' WHERE `id` = '".$id."'";
			$results = $wpdb->query($sql);			
		}			
		echo '<div class="updated"><p>'.__('Module Templates have been updated!', 'wprobot').'</p></div>';			
	}
	
	if($_POST['tsave']){
		$id = $_POST['tnum'];
		$content = $_POST["tcontent"];
		$title = $_POST["ttitle"];
		$name = $_POST["tname"];
		$comments_amazon = $_POST["comments_amazon"];
		$comments_yahoo = $_POST["comments_yahoo"];
		$comments_flickr = $_POST["comments_flickr"];
		$comments_youtube = $_POST["comments_youtube"];
		$sql = "UPDATE " . $wpr_table_templates . " SET `content` = '".$content."',`title` = '".$title."',`name` = '".$name."',`comments_amazon` = '".$comments_amazon."',`comments_flickr` = '".$comments_flickr."',`comments_yahoo` = '".$comments_yahoo."',`comments_youtube` = '".$comments_youtube."' WHERE `id` = '".$id."'";
		$results = $wpdb->query($sql);	

		if ($results) {				
			echo '<div class="updated"><p>'.__('Template has been updated!', 'wprobot').'</p></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Error: Template could not be updated!', 'wprobot').'</p></div>';				
		}			
	}
	
	if($_POST['tdelete']){
		$id = $_POST['tnum'];
		$sql = "DELETE FROM " . $wpr_table_templates . " WHERE `id` = '".$id."'";
		$results = $wpdb->query($sql);	

		if ($results) {				
			echo '<div class="updated"><p>'.__('Template has been deleted!', 'wprobot').'</p></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Error: Template could not be deleted!', 'wprobot').'</p></div>';				
		}			
	}	
	
	if($_POST['tcopy']){
		$id = $_POST['tnum'];
		$templ = $wpdb->get_row("SELECT * FROM " . $wpr_table_templates . " WHERE `id` = '".$id."'");
		$content = $templ->content;
		$type = $templ->type;
		$title = $templ->title;
		$name = $templ->name;
		$comments_amazon = $templ->comments_amazon;
		$comments_yahoo = $templ->comments_yahoo;
		$comments_flickr = $templ->comments_flickr;
		$comments_youtube = $templ->comments_youtube;
		$sql = "INSERT INTO " . $wpr_table_templates . " SET type = '$type', content = '$content',`title` = '".$title."',`name` = '".$name."',`comments_amazon` = '".$comments_amazon."',`comments_flickr` = '".$comments_flickr."',`comments_yahoo` = '".$comments_yahoo."',`comments_youtube` = '".$comments_youtube."'";
		$results = $wpdb->query($sql);	

		if ($results) {				
			echo '<div class="updated"><p>'.__('Template has been copied!', 'wprobot').'</p></div>';		
		} else {
			echo '<div class="updated"><p>'.__('Error: Template could not be copied!', 'wprobot').'</p></div>';				
		}			
	}		
	
	include("display-templates.php");
}

function wpr_sub_options() {
	global $wpdb, $wpr_table_campaigns, $wpr_table_templates, $wpr_table_errors, $wpr_table_posts, $modules;

	$options = unserialize(get_option("wpr_options"));	

	if($_POST['wpr_uninstall']) {
		$results = $wpdb->query("DROP TABLE $wpr_table_posts,$wpr_table_templates,$wpr_table_campaigns,$wpr_table_errors;");
		delete_option("wpr_options");
		delete_option("wpr_cron");	
		delete_option("wpr_cloak");	
		delete_option('wpr_db_ver');
		$options = "";
		echo '<div class="updated"><p>'.__('WP Robot has been uninstalled. You can now disable and delete the plugin.', 'wprobot').'</p></div>';		
	}		
	
	if ($options['wpr_installed'] != "yes") {
		echo '<div class="wrap"><h2>WP Robot</h2><div class="updated"><h3>Installation</h3><p>'.__('Please go <a href="?page=wpr-campaigns">here</a> to finish the installation of WP Robot first.', 'wprobot').'</p></div></div>';
		return false;
	}		
	
	if($_POST['wpr_options_default']) {
		$options = wpr_default_options(1);
		echo '<div class="updated"><p>'.__('Options have been reset.', 'wprobot').'</p></div>';			
	}		
	
	if($_POST['wpr_templates_default']) {
		$results = $wpdb->query("TRUNCATE TABLE $wpr_table_templates;");
		if($results) {$results2 = $wpdb->query($options["wpr_sql"]);}
		if($results2) {echo '<div class="updated"><p>'.__('Templates have been reset.', 'wprobot').'</p></div>';}	
		else {echo '<div class="updated"><p>'.__('Templates could not be reset.', 'wprobot').'</p></div>';}
	}			
	
	if($_POST['wpr_import']) {
		$options = wpr_import_options();			
		echo '<div class="updated"><p>'.__('Settings have been imported.', 'wprobot').'</p></div>';		
	}		

	if($_POST['wpr_clear_log']) {
		$results = $wpdb->query("TRUNCATE TABLE $wpr_table_errors;");
		echo '<div class="updated"><p>'.__('Log has been cleared.', 'wprobot').'</p></div>';		
	}		

	if($_POST['wpr_clear_posts']) {
		$results = $wpdb->query("TRUNCATE TABLE $wpr_table_posts;");			
		echo '<div class="updated"><p>'.__('History has been cleared.', 'wprobot').'</p></div>';		
	}
	
	if($_POST['wpr_update_email']) {
		$options['wpr_email'] = wpr_update_email($options['wpr_email'],$_POST['wpr_email']);
	}
	
	if($_POST['wpr_options_save']) {
		$options['wpr_resetcount'] = $_POST['wpr_resetcount'];
		$options['wpr_autotag'] = $_POST['wpr_autotag'];
		$options['wpr_badwords'] = $_POST['wpr_badwords'];
		$options['wpr_randomize'] = $_POST['wpr_randomize'];
		$options['wpr_randomize_comments'] = $_POST['wpr_randomize_comments'];
		$options['wpr_help'] = $_POST['wpr_help'];
		$options['wpr_poststatus'] = $_POST['wpr_poststatus'];
		$options['wpr_cb_affkey'] = $_POST['wpr_cb_affkey'];		
		$options['wpr_cb_filter'] = $_POST['wpr_cb_filter'];	
		$options['wpr_openlinks'] = $_POST['wpr_openlinks'];
		$options['wpr_authorid'] = $_POST['wpr_authorid'];	
		$options['wpr_err_retries'] = $_POST['wpr_err_retries'];
		$options['wpr_err_maxerr'] = $_POST['wpr_err_maxerr'];
		$options['wpr_err_minmod'] = $_POST['wpr_err_minmod'];	
		$options['wpr_err_disable'] = $_POST['wpr_err_disable'];
		$options["wpr_global_exclude"] = $_POST['wpr_global_exclude'];
		$options['wpr_check_unique_old'] = $_POST['wpr_check_unique_old'];
		foreach($modules as $module) {
			$function = "wpr_".$module."_options_default";
			if(function_exists($function)) {
				$moptions = $function();
				foreach($moptions as $moption => $default) {
					$options[$moption] = $_POST[$moption];
				}
			}
		}
		update_option("wpr_options", serialize($options));	
		update_option('wpr_cloak',$_POST['wpr_cloak']);
		echo '<div class="updated"><p>'.__('Options have updated.', 'wprobot').'</p></div>';				
	}	
	
	include("display-options.php");	
}

function wpr_insertpost($content,$title,$cat) {
	remove_filter('content_save_pre', 'wp_filter_post_kses');

	if($content == "" || $title == "") {return false;}
	
	$options = unserialize(get_option("wpr_options"));	
	
	if($_POST['postdate']) {
		$post_date= $_POST['postdate'];
		$post_date_gmt= $post_date;			
	} else {
		$post_date= current_time('mysql');
		$post_date_gmt= current_time('mysql', 1);
	}
	$post_author=1;
	if ($options['wpr_authorid']!='') {
		$post_author=$options['wpr_authorid'];
	}
	if ($options['wpr_poststatus']=='published') {
		$post_status = 'publish';
	} elseif ($options['wpr_poststatus']=='draft') {
		$post_status = 'draft';
	}
	$post_category = array($cat);
	
	if ($options['wpr_openlinks']=='yes') {$content = str_replace("<a ", '<a target="_blank" ', $content);}
	$post_content=$content;

	$badwords = explode(";",$options['wpr_badwords']);
	$badchars = array(",", ":", "(", ")", "]", "[", "?", "!", ";", "-", '"');
	
	$title2 = str_replace($badchars, "", $title);		
	
	$items = explode(' ', $title2);
	$tags_input = array();				
	for($k = 0, $l = count($items); $k < $l; ++$k){		
		$long = strlen($items[$k]);
		if ($long > 3) {
			if (!in_array(strtolower($items[$k]), $badwords)) {
				$tags_input[] = $items[$k];
			}
		}
	}		
	if($options['wpr_autotag'] != 'Yes') {$tags_input = "";}
	
	$post_title = trim($title);
	
	$post_data = compact('post_content','post_title','post_date','post_date_gmt','post_author','post_category', 'post_status', 'tags_input');		

	$post_data = add_magic_quotes($post_data);
	$post_ID = wp_insert_post($post_data);
	if ( is_wp_error( $post_ID ) ) {
		echo "\n" . $post_ID->get_error_message();
		return false;			
	} else {
		return $post_ID;		
	}
}

function wpr_insertcomments($postid,$commentsarray,$time="",$transcomments=0,$translation="") {

	$options = unserialize(get_option("wpr_options"));	

	if($time=="") {
		$comment_date = current_time('mysql');
	}
	
    foreach ($commentsarray as $comments) {

		if($options['wpr_randomize_comments'] == 'yes') {
			$ccount = count($comments);
			$chalf = ceil($ccount / 2);
			$cnum = rand($chalf,$ccount);
		} else {
			$cnum = count($comments);
		}

		$i = 0;
		foreach ($comments as $comment) {
			if($i < $cnum) {
				$comment_post_ID=$postid;

				list( $today_year, $today_month, $today_day, $hour, $minute, $second ) = split( '([^0-9])', $comment_date );	
				$comment_date = mktime($hour, $minute + rand(0, 59), $second + rand(0, 59), $today_month, $today_day, $today_year);
				$comment_date=date("Y-m-d H:i:s", $comment_date); 		
				$comment_date_gmt = $comment_date;					

				$rnd= rand(1,9999);
				$comment_author_email="someone$rnd@domain.com";
				$comment_author=$comment["author"];
				$comment_author_url='';  
				$comment_content="";
				/*if($comment["rating"] && function_exists("wpr_star_rating")) {
					$image = wpr_star_rating($comment["rating"]);
					$comment_content.="<strong>Rating: ".$image."</strong><br/>";
				}*/
				$comment_content.=$comment["content"];
				if($transcomments==1) {$comment_content = wpr_translate($comment_content,$translation["from"],$translation["to1"],$translation["to2"]);}				
				$comment_type='';
				$user_ID='';
				$comment_approved = 1;
				$commentdata = compact('comment_post_ID', 'comment_date', 'comment_date_gmt', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_ID', 'comment_approved');
				$comment_id = wp_insert_comment( $commentdata );
			}
			$i++;
		}
	}
}

function wpr_random_tags($content) {

	preg_match_all('#\[select(.*)\]#iU', $content, $matches, PREG_SET_ORDER);
	if ($matches) {
		foreach($matches as $match) {
			$match[1] = substr($match[1], 1);
			$paras = explode("|",$match[1]);
			$randp = array_rand($paras);
			
			$content = str_replace($match[0], $paras[$randp], $content);			
		}
	}	
	preg_match_all('#\[random(.*)](.*)[\/random]\]#iU', $content, $matches, PREG_SET_ORDER);
	if ($matches) {
		foreach($matches as $match) {
			$match[1] = substr($match[1], 1);
			if($match[1] >= rand(1,100)) {
				$match[2] = str_replace("[/rando", "", $match[2]);	
				$content = str_replace($match[0], $match[2], $content);	
			} else {
				$content = str_replace($match[0], "", $content);				
			}
		}
	}
	
	return $content;
}

function wpr_run_cron($camp_id="") {
	global $wpdb, $wpr_table_campaigns;
	
	if(isset($camp_id)) {
		wpr_poster($camp_id);
	} else {
		$results = $wpdb->get_results("SELECT id FROM " . $wpr_table_campaigns . ""); 
		foreach($results as $result) {
			wpr_poster($result->id);
		}
	}
}

function wpr_poster($camp_id, $keyword="", $manual=0) {

	$options = unserialize(get_option("wpr_options"));			
	$maxretry = $options['wpr_err_retries'];
	$retry = 0;
	while($posted != true) {
		$posted = wpr_post($camp_id, $keyword, $retry, $manual);
		$retry++;
		
		if($retry > $maxretry) {return false;}
	}
	if($posted) {
		return true;
	}
}

function wpr_post($camp_id, $keyword="", $retry=1, $manual=0) {
	global $wpdb, $wpr_table_campaigns, $wpr_table_posts, $wpr_table_errors;

	if($retry > 0) {$retrymsg = " <b>(Retry $retry)</b>";} else {$retrymsg = "";}	
	$time = current_time('mysql');	
	$errors = array();
	
    $options = unserialize(get_option("wpr_options"));	
	$result = $wpdb->get_row("SELECT * FROM " . $wpr_table_campaigns . " WHERE id = '$camp_id'"); 
	if($result->pause == 1 && $manual == 0) {return false;}
	
	// select KEYWORD
	$keywords = unserialize($result->keywords);
	if(!$keyword) {
		if(empty($keywords)) {
			// SAVE and DISPLAY error
			$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
			$esql .= " ( '$camp_id', '$keyword', '', 'Inactive', ".__("'Post skipped because no keywords were found in the campaign.$retrymsg'", 'wprobot').", '$time' );";
			$results = $wpdb->query($esql);			
			return false;		
		}			
		// REMOVE KEYWORDS WHERE SKIPPED = 5 (better way without loop?)
		$keywords2 = $keywords;
		foreach($keywords as $key => $keyword) {
			if($keyword["skipped"] >= $options['wpr_err_disable'] && !$keyword["feed"]) {
				unset($keywords2[$key]);
			}
		}
		//echo "<pre>";print_r($keywords2);echo "</pre>";	
		//$keywords = array_values($keywords);		
		$rnd = array_rand($keywords2);
		$keyword = $keywords[$rnd][0];
		if($rnd === "" || $keyword === "" && !empty($keyword["feed"]) || !is_numeric($rnd)) {
			// SAVE and DISPLAY error
			$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
			$esql .= " ( '$camp_id', '$keyword', '', 'Inactive', ".__("'No active keywords or feeds for this campaign.$retrymsg'", 'wprobot').", '$time' );";
			$results = $wpdb->query($esql);			
			return false;		
		}		
	} else {
		foreach($keywords as $key => $kw) {
			if($kw[0] == $keyword) {
				$rnd = $key;
			}
		}
	}
	$keywordsbackup = $keywords[$rnd];
	
	// select CATEGORY
	$categories = unserialize($result->categories);
	if(count($categories) == 1) {
		$category = $categories[0]["id"];
	} else {
		$category = $categories[$rnd]["id"];	
	}	
	
	// select TEMPLATE
	$templates = unserialize($result->templates);
	$i = 1;
	foreach($templates as $tchance) {
		$tch[$i] = $templates[$i]["chance"];
		$i++;
	}
	
	$random = rand(1,100);
	foreach($tch as $name => $chance){
		$luck += $chance;
		if($random <= $luck && empty($templatenum)){
			$templatenum = $name;
		}
	} 	
	$template = $templates[$templatenum]["content"];

	$content = $template;//echo $template."<br>";
	$content = str_replace("{keyword}", $keyword, $content);
	$content = str_replace("{Keyword}", ucwords($keyword), $content);
	$content = str_replace("{title}", $title, $content);	
	$content = str_replace("{catlink}", get_category_link( $category ), $content);	

	// THUMBNAIL
	preg_match_all('#\{thumbnail(.*)\}#iU', $content, $matches, PREG_SET_ORDER);
	if ($matches) {
		foreach($matches as $match) {
			$match[1] = substr($match[1], 1);
			if($match[1]) {$tkw = $match[1];} else {$tkw = $keywords[$rnd][0];}
			$thumbnail = wpr_flickr_getthumbnail($tkw);
			if(!empty($thumbnail["error"])) {$errors[] = $thumbnail["error"];}
			$content = str_replace($match[0], $thumbnail[0]["content"], $content);				
		}
	}	
	// RANDOM Tags
	$content = wpr_random_tags($content);
	
	$title = $templates[$templatenum]["title"];
	$title = str_replace("{keyword}", $keyword, $title);
	$title = str_replace("{Keyword}", ucwords($keyword), $title);
	
	// RANDOM Tags
	$title = wpr_random_tags($title);

	$raz[0] = "{";$raz[1] = "}";
	preg_match_all("/\\".$raz[0]."[^\\".$raz[1]."]+\\".$raz[1]."/s", $content, $matches);
	$counts = array_count_values  (  $matches[0]  ); //echo $counts["{amazon}"];		
	$modulesnum = count($matches[0]);
	if($modulesnum <= 0) {
		// SAVE and DISPLAY error
		$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
		$esql .= " ( '$camp_id', '$keyword', '', 'Inactive', ".__("'Post skipped because no modules were found in the template.$retrymsg'", 'wprobot').", '$time' );";
		$results = $wpdb->query($esql);			
		return false;		
	}		

	$usql = "INSERT INTO ".$wpr_table_posts." ( campaign, keyword, module, unique_id, time ) VALUES";
	// Get Content for each Module
	// ["content"] = Content of the item (replaced module template code)
	// ["title"] = Title of the item (i.e. Product title)
	// ["unique"] = Unique ID (i.e. ASIN)
	// ["comments"] = Possible comment content of the item (i.e. reviews)
	$contents = array();
	$commentsarray = array();
	$titleerror = 0;
	$duplicatecount = 0;

	foreach($counts as $module => $count) {
		$modulname = str_replace(array("{","}"), "", $module);
		$function = "wpr_".$modulname."post";
		
		$optional = "";$comments = "";
		switch ($modulname) {
			case "amazon":
				$optional = array($result->amazon_department,$keywords[$rnd]["node"]);
				break;
			case "ebay":
				$optional = $result->ebay_cat;
				break;
			case "flickr":			
				$comments = $templates[$templatenum]["comments"]["$modulname"];
				break;
			case "youtube":
				$comments = $templates[$templatenum]["comments"]["$modulname"];
				break;
			case "yahooanswers":
				$optional = $result->yahoo_cat;
				$comments = $templates[$templatenum]["comments"]["$modulname"];
				break;	
			case "rss":
				$optional = $keywords[$rnd]["feed"];
				break;							
		}
		
		// GET CONTENT
		if(function_exists($function)) {
			$contents["$modulname"] = $function($keyword, $count, $keywords[$rnd][1]["$modulname"], $optional, $comments);
			if(!empty($contents["$modulname"]["error"])) {$errors[] = $contents["$modulname"]["error"];}
		} else {
			$title = str_replace("{".$modulname."title}", "", $title);
			$errors[] = array("module" => ucwords($modulname), "reason" => "Not Installed", "message" => __("$modulname is not installed on this weblog and has been skipped.", 'wprobot'));						
		}
		
		// CONTENT REPLACE
		$$modulname = 0;
		$dupl = 0;
	
		foreach ($matches[0] as $element) {
			if($element=="{".$modulname."}") {
				$unique = $contents["$modulname"][$$modulname]["unique"];
				if($unique != "" || $modulname == "ebay" ) {	
					$dcheck = wpr_check_unique($unique);
					if($options['wpr_check_unique_old'] == "Yes") {$dcheck2 = wpr_check_unique_old($contents["$modulname"][$$modulname]["title"]);} else {$dcheck2 = false;}
					if($dcheck == false && $dcheck2 == false) {
						$content = preg_replace('/\{'.$modulname.'\}/', $contents["$modulname"][$$modulname]["content"], $content, 1);
						if(!isset($contents["$modulname"]["error"]) ) {
							$unique = $wpdb->escape($unique);
							$usql .= " ( '$camp_id', '$keyword', '$modulname', '$unique', '$time' ),";
						}
						if($templates[$templatenum]["comments"]["$modulname"] == 1) {$commentsarray[] = $contents["$modulname"][$$modulname]["comments"];}
					} else {
						// DUPLICATE POST
						$dupl = 1;
						$duplicatecount++;
						$content = preg_replace('/\{'.$modulname.'\}/', "", $content, 1);	
						$errors[] = array("module" => ucwords($modulname), "reason" => "Duplicate", "message" => __("Skipping $modulname module because the content has already been posted.", 'wprobot'));						
					}
				}
				
				//echo "------------DEBUG START------------<br/>";
				//echo $dupl." DUPLICATE<br/>";
				//echo $contents["$modulname"]["error"]." ERROR<br/>";
				//echo $counts["{".$modulname."}"]." FIRST COUNT<br/>";
				//echo $$modulname." SECOND COUNT<br/>";
				// TITLE REPLACE	
				$titlecheck = strpos($title, "{".$modulname."title}");
				$titlecheck2 = strpos($title, "{title}");				
				$modulecheckvar = $$modulname + 1;
				if ($titlecheck !== false || $titlecheck2 !== false) {
					if ($counts["{".$modulname."}"] > $modulecheckvar && $dupl == 1 || $counts["{".$modulname."}"] > $modulecheckvar && !empty($contents["$modulname"]["error"])) {
						// Dont Replace Title because there is another title module item
					} elseif($counts["{".$modulname."}"] <= $modulecheckvar && $dupl == 1) {
						// Title Duplicate					
						$titleduplicate = 1;		
					} elseif($counts["{".$modulname."}"] <= $modulecheckvar && !empty($contents["$modulname"]["error"]) || $counts["{".$modulname."}"] <= $modulecheckvar && empty($contents["$modulname"][0]["title"])) {
						// Title Error
						$titleerror = 1;
					} else {
						// Replace Title
						$title = str_replace("{".$modulname."title}", $contents["$modulname"][$$modulname]["title"], $title);
						$title = str_replace("{title}", $contents["$modulname"][$$modulname]["title"], $title);	
					}
				}
				$$modulname++;				
			}		
		}	

		// INCREASE NUMS
		if(empty($contents["$modulname"]["error"])) { // don't increase NUMs if ERROR for module
			$keywords[$rnd][1]["$modulname"] = $keywords[$rnd][1]["$modulname"] + $$modulname;
			// RESET POST COUNT
			if($keywords[$rnd][1]["$modulname"] > $options['wpr_resetcount'] && $options['wpr_resetcount'] != "no") {$keywords[$rnd][1]["$modulname"] = 0;}
			if($modulename == "ebay" && $keywords[$rnd][1]["$modulname"] > 50) {$keywords[$rnd][1]["$modulname"] = 0;}
		}	
		$content = str_replace("{".$modulname."}","",$content);		
	}

	// check ERRORS
	$errorsnum = count($errors);	
	$skip = 0;
	if(!empty($keywords[$rnd]["feed"])) {$errkeyword = "Feed";} elseif(!empty($keywords[$rnd]["node"])) {$errkeyword = "Node:".$keywords[$rnd]["node"];} else {$errkeyword = $keyword;}
	
	// EXCLUDE KEYWORDS Check $options["wpr_global_exclude"]
	$excludeskip = 0;
	$excludes = unserialize($result->excludekws);
	
	$globals = str_replace("\r", "", $options["wpr_global_exclude"]);
	$globals = explode("\n", $globals);
	$excludes = array_merge($excludes, $globals);
	
	if(!empty($excludes)) {
		foreach($excludes as $exclude) {
			if($exclude != "" && $exclude != " " ) {
				$excheck = strpos($content, $exclude);
				if($excheck === false) {
				} else {
					$excludeskip = 1;	$errors = array();
					$errors[] = array("module" => "", "reason" => "Exclude", "message" => __("Skipping post because exclude keyword $exclude was found.$retrymsg", 'wprobot'), "time" => "$time");
					break;
				}
			}
		}
	}

	if($excludeskip == 0) {
		// MARK KEYWORD AS yellow, orange, etc
		$modulessuccess = $modulesnum - $errorsnum;
		$duplsuccess = $modulesnum - $duplicatecount;
		if($duplicatecount > $options["wpr_err_maxerr"] || $duplsuccess < $options["wpr_err_minmod"] || $titleduplicate == 1) { // DUPLICATE ERROR - WiTHOUT skipped INCREASE
			$errors[] = array("module" => "", "reason" => "Duplicate Content", "message" => __("Skipping post to prevent duplicate content.$retrymsg", 'wprobot'), "time" => "$time");	
			$skip = 1;		
		} elseif($titleerror == 1) {
			$keywords[$rnd] = $keywordsbackup;		
			$keywords[$rnd]["skipped"] = $keywords[$rnd]["skipped"] + 1;
			$errors[] = array("module" => "", "reason" => "Post skipped", "message" => __("Skipping post because the main module (title module) returned an error.$retrymsg", 'wprobot'), "time" => "$time");	
			$skip = 1;				
		} elseif($errorsnum > $options["wpr_err_maxerr"] || $modulessuccess < $options["wpr_err_minmod"]) {
			$keywords[$rnd] = $keywordsbackup;		
			$keywords[$rnd]["skipped"] = $keywords[$rnd]["skipped"] + 1;
			$errors[] = array("module" => "", "reason" => "Post skipped", "message" => __("Skipping post because too many module errors were encountered.$retrymsg", 'wprobot'), "time" => "$time");	
			$skip = 1;
		} else {
			$keywords[$rnd]["skipped"] = 0;	
		}	
	}
		
	// SAVE ERRORS
	if($errorsnum > 0 || $excludeskip == 1 || $titleerror == 1) {
		$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
		foreach($errors as $error) {
			$error["message"] = $wpdb->escape($error["message"]);
			$esql .= " ( '$camp_id', '$errkeyword', '".$error["module"]."', '".$error["reason"]."', '".$error["message"]."', '$time' ),";
		}
		$esql = substr_replace($esql ,";",-1);
		$results = $wpdb->query($esql);		
	}	
	
	// SKIP if EXCLUDE found, errors > MAXERRORS or modules < MINMODULES
	if($excludeskip == 1 || $skip == 1) {
		// - update campaign entry with new NUMS	
		$keywords = serialize($keywords);
		$sql = "UPDATE " . $wpr_table_campaigns . " SET `keywords` = '".$keywords."' WHERE `id` = '".$camp_id."'";
		$results = $wpdb->query($sql);			
		return false;
	}

	// TRANSLATION
	$translation = unserialize($result->translation);
	if($translation["chance"] >= rand(1,100)) {
		if($translation["from"] != "no" && $translation["to1"] != "no") {
			$translationcontent = wpr_translate($content,$translation["from"],$translation["to1"],$translation["to2"]);
			//print_r($translationcontent);
			if($options["wpr_trans_titles"] == "yes") {
				$translationtitle = wpr_translate($title,$translation["from"],$translation["to1"],$translation["to2"]);
			}
			if(!empty($translationcontent["error"]["reason"])) {
				$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
				$esql .= " ( '$camp_id', '$errkeyword', 'Translation', '".$translationcontent["error"]["reason"]."', '".$translationcontent["error"]["message"]."', '$time' );";
				$results = $wpdb->query($esql);		
				if($options['wpr_trans_fail'] == "skip") {
					$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
					$esql .= " ( '$camp_id', '$errkeyword', '', 'Post skipped', 'Skipping post because translation failed.$retrymsg', '$time' );";
					$results = $wpdb->query($esql);		
					return false;
				}
			} elseif(empty($translationcontent)) {
				$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
				$esql .= " ( '$camp_id', '$errkeyword', 'Translation', 'Translation Failed', '".__("The post could not be translated.","wprobot")."', '$time' );";
				$results = $wpdb->query($esql);		
				if($options['wpr_trans_fail'] == "skip") {
					$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
					$esql .= " ( '$camp_id', '$errkeyword', '', 'Post skipped', 'Skipping post because translation failed.$retrymsg', '$time' );";
					$results = $wpdb->query($esql);		
					return false;
				}
			} else {
				$content = $translationcontent;
				if($options["wpr_trans_titles"] == "yes") {$title = $translationtitle;}
				if($translation["comments"] == 1) {$transcomments = 1;} else {$transcomments = 0;}
			}
		}
	}
	
	// REPLACES
	$replaces = unserialize($result->replacekws);
	if(!empty($replaces)) {	
		foreach($replaces as $replace) {
			if($replace["chance"] >= rand(1,100)) {
				$content = str_replace(" ".$replace["from"], " ".$replace["to"], $content);
			}
		}
	}
	
	// INSERT POST into db	
	$insert = wpr_insertpost($content,$title,$category);	  
	if($insert) {
		// - update campaign entry with new NUMS	
		$posts_created = $result->posts_created + 1;
		$keywords[$rnd][1]["total"] = $keywords[$rnd][1]["total"] + 1;	
		$keywords = serialize($keywords);
		$sql = "UPDATE " . $wpr_table_campaigns . " SET `keywords` = '".$keywords."', `posts_created` = '".$posts_created."' WHERE `id` = '".$camp_id."'";
		$results = $wpdb->query($sql);	

		// - save UNIQUE IDS to post table
		$usql = substr_replace($usql ,";",-1);
		$results = $wpdb->query($usql);	
		
		// - insert COMMENTS 
		wpr_insertcomments($insert,$commentsarray,"",$transcomments,$translation);
		
		// - insert CUSTOM FIELDS
		if($counts["{amazon}"] > 0) {
			add_post_meta($insert, 'ma_amazonpost', $contents["amazon"][0]["unique"]);
		}
		$customfield = unserialize($result->customfield);
		$cfname = $customfield["name"];
		$cfcontent = $customfield["value"];
		if($cfcontent != "" && $cfname != "") {
			if(!empty($contents["amazon"][0]["customfield"])) {$ximage = $contents["amazon"][0]["customfield"];} elseif(!empty($contents["youtube"][0]["customfield"])) {$ximage = $contents["youtube"][0]["customfield"];} elseif(!empty($contents["flickr"][0]["customfield"])) {$ximage = $contents["flickr"][0]["customfield"];} elseif(!empty($thumbnail[0]["customfield"])) {$ximage = $thumbnail[0]["customfield"];} else {$ximage = "";}
			$cfcontent = str_replace("{image}", $ximage, $cfcontent);
			$cfcontent = str_replace("{amazonthumbnail}", $contents["amazon"][0]["customfield"], $cfcontent);
			$cfcontent = str_replace("{youtubethumbnail}", $contents["youtube"][0]["customfield"], $cfcontent);
			$cfcontent = str_replace("{flickrimage}", $contents["flickr"][0]["customfield"], $cfcontent);
			$cfcontent = str_replace("{thumbnail}", $thumbnail[0]["customfield"], $cfcontent);	
			if(!empty($cfcontent)) {add_post_meta($insert, $cfname, $cfcontent);}
		}
		
		// - display success message IN OTHER FUNCTION
		$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
		$esql .= " ( '$camp_id', '$errkeyword', '', 'Post created', ".__("'The post has been created successfully.$retrymsg'", 'wprobot').", '$time' );";
		$results = $wpdb->query($esql);		
		return true;
		
	} else {
		// SAVE and DISPLAY error
		$esql = "INSERT INTO ".$wpr_table_errors." ( campaign, keyword, module, reason, message, time ) VALUES";
		$esql .= " ( '$camp_id', '$errkeyword', '', 'Insert failed', ".__("'The post could not be inserted into the Wordpress database.$retrymsg'", 'wprobot').", '$time' );";
		$results = $wpdb->query($esql);			
		return false;
	}
}

function wpr_checkpost() {
	$options = unserialize(get_option("wpr_options"));	
	if ($options["createposts"] == "yes") {
		echo '<p>Powered by <a href="http://wprobot.net/" title="Wordpress autoblogging plugin">WP Robot</a></p>';
	}
}
add_action('wp_footer', 'wpr_checkpost'); 

// LINK CLOAKING
class wpr_linkcloaker {	
	var $linkno=0;
	var $myfile='';
	var $myfolder='';
	 
	function wpr_linkcloaker($linkno=0){
		$this->linkno = $linkno;
		$this->myfile = str_replace('\\', '/',__FILE__);
		$this->myfile = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', $this->myfile);
		add_filter('the_content', array(&$this,'contentcloaker'), 15); 
		add_filter('mod_rewrite_rules', array(&$this,'rewriterules'));
	}
	 
	function ma_esc($text){
		$text=strip_tags($text);
		$text=preg_replace('/[^a-z0-9_]+/i', '_', $text);	
		if(strlen($text)<1) { $text='link'; };	
		return $text;
	}

	function rewriter($matches){
		global $post;

		$this->linkno++;	
		$url = $matches[3];	
		$parts = @parse_url($url);
	
		if(!$parts || !isset($parts['scheme']) || !isset($parts['host'])) return $matches[0];
	  
		if( preg_match('/www.amazon/i', $matches[3]) || preg_match('/clickbank/i', $matches[3]) || preg_match('/rover.ebay/i', $matches[3])) {
			$base = get_option( 'home' );
			if ( $base == '' ) {
				$base = get_option( 'siteurl' );
			}
			
			$url = trailingslashit($base)."go".'/'.$this->ma_esc($matches[5]).
				 '/'.($post->ID)."/".$this->linkno;
				 
			//$url = trailingslashit($base)."go".'/to'.
			//	 '/'.($post->ID)."/".$this->linkno;				 
			
			$link = $matches[1].$matches[2].$url.$matches[2].$matches[4].$matches[5].$matches[6]; 

			return $link;	
		} else {return $matches[0];}
	}

	function contentcloaker($content){
		if(is_page()){
			return $content;
		} else {
		$this->linkno=0;
		$wplc_url_pattern='/(<a[\s]+[^>]*href\s*=\s*)([\"\'])([^\2>]+?)\2([^<>]*>)((?sU).*)(<\/a>)/i';
		
		$content=preg_replace_callback($wplc_url_pattern, array(&$this,'rewriter'), $content);
		return $content;
		}
	}
	 
	function rewriterules($rules){
		global $wp_rewrite;

		$myfolder = basename(dirname(__FILE__));
		
		$redirector = WP_PLUGIN_URL . '/' . $myfolder . '/cloak.php';	

		$pattern = '^' . "go".'/([^/]*)/([0-9]+)/([0-9]+)/?$';
		$replacement=$redirector.'?post_id=$2&link_num=$3&cloaked_url=$0';
		
		$pattern_static = '^' . "go".'/([^/]+)[/]?$';
		$replacement_static=$redirector.'?name=$1&cloaked_url=$0';
		
		$cloakrules="\n# WP Robot Link Cloaking START\n";
		$cloakrules.="<IfModule mod_rewrite.c>\n";
		$cloakrules.="RewriteEngine On\n";
		$cloakrules.="RewriteRule $pattern $replacement [L]\n";
		$cloakrules.="RewriteRule $pattern_static $replacement_static [L]\n";
		$cloakrules.="</IfModule>\n";
		$cloakrules.="# WP Robot Link Cloaking END\n\n";
		
		$rules=$cloakrules.$rules;
		
		return $rules;
	}

}
 
if(get_option('wpr_cloak') == 'Yes') {
	$wpr_linkcloaker = new wpr_linkcloaker();
}
add_action( "wprobothook", 'wpr_poster' );

// WP ROBOT SHORTCODE          // {wprobot module=ebay keyword=wordpress start=1}
function wpr_shortcode( $data , $postarr="" ) {
	$content = $data['post_content'];
	
	preg_match_all('#\{wprobot module=(.*) keyword=(.*) start=(.*) num=(.*)\}#iU', $content, $matches, PREG_SET_ORDER);//print_r($matches);	
	if ($matches) {
		foreach($matches as $match) {
			$module = str_replace('\"','',$match[1]);
			$keyword = str_replace('\"','',$match[2]);
			$start = str_replace('\"','',$match[3]);	
			$num = str_replace('\"','',$match[4]);
			$module = str_replace('"','',$module);
			$keyword = str_replace('"','',$keyword);
			$start = str_replace('"','',$start);
			$num = str_replace('"','',$num);
			if(empty($num)) {$num = 1;}
			if(empty($start)) {$start = 1;}
			
			$function = "wpr_".$module."post";
			
			if(function_exists($function)) {
				$gets = $function($keyword, $num, $start, "", "");
				if($num == 1) {$get = $gets[0]["content"];} else {
					$get = "";
					foreach($gets as $geti) {$get .= $geti["content"];}
				}		
			} else {$get = "ERROR: Function does not exist.";}

			$content = str_replace($match[0], $get, $content);			
		}
	}	
	
	$data['post_content'] = $content;
	return ( $data );
}
add_filter ( 'wp_insert_post_data' , 'wpr_shortcode' , 99 );

class wpr_post_shortcode_button {
	var $pluginname = "wprobot";

	function wpr_post_shortcode_button()  {
		// Modify the version when tinyMCE plugins are changed.
		add_filter('tiny_mce_version', array (&$this, 'change_tinymce_version') );
		
		// init process for button control
		add_action('init', array (&$this, 'add_buttons') );
	}

	function add_buttons() {
		// Don't bother doing this stuff if the current user lacks permissions
		if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;
		
		// Add only in Rich Editor mode
		if ( get_user_option('rich_editing') == 'true') {
			// add the button for wp2.5 in a new way
			add_filter("mce_external_plugins", array (&$this, "add_tinymce_plugin" ), 5);
			add_filter('mce_buttons', array (&$this, 'register_button' ), 5);
		}
	}
	
	// used to insert button in wordpress 2.5x editor
	function register_button($buttons) {
		array_push($buttons, "separator", $this->pluginname );
		return $buttons;
	}
	
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function add_tinymce_plugin($plugin_array) {    
		$plugin_array[$this->pluginname] =  WPR_URLPATH.'tinymce/editor_plugin.js';
		return $plugin_array;
	}
	
	function change_tinymce_version($version) {
		return ++$version;
	}
}

$tinymce_button = new wpr_post_shortcode_button();	
	
	
?>
